options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])
library_location <- options[3]

if(library_location == ""){
  library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Component specific
min_cov <- as.numeric(options[6])
min_dep <- as.numeric(options[7])

original_files <- options[8]
original_files <- strsplit(original_files, split=",")[[1]]

original_base_names <- options[9]
original_base_names <- strsplit(original_base_names, split=",")[[1]]

setwd(directory_name)

#For my own dev use

suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(cowplot, lib.loc = library_location)))

suppressMessages(suppressWarnings(library(bit64, lib.loc = library_location)))

#Original read counts is annoying... I'll have to pass this in
#original_files <- list.files(full.names = T, path = "Metapop_BAMs")


#TODO update lengths, file paths
cov_depth <- list.files(path="MetaPop/03.Breadth_and_Depth", full.names = T, pattern="breadth_and_depth")
c_d_names <- substring(cov_depth, 30, nchar(cov_depth)-22)

output_bams <- list.files(path = "MetaPop/02.Filtered_Samples", full.names = T)
output_bams <- output_bams[!grepl(".bai", output_bams)]

cl <- makeCluster(min(threads, detectCores()))

registerDoParallel(cl)

orig_read_counts <- foreach(i = original_files, .combine = c) %dopar% {
  
  as.numeric(system(paste0("samtools view -c ", i), intern = T))
  
}

stopCluster(cl)

#TODO these names won't work.

overall_summaries <- data.table(sample = original_base_names, read_counts = orig_read_counts, finish_counts = 0)

#'.BAM' already stripped.
#overall_summaries$sample = substr(overall_summaries$sample, 1, nchar(overall_summaries$sample)-4)

cl <- makeCluster(min(threads, detectCores()))

registerDoParallel(cl)

finish_read_counts <- foreach(i = output_bams, .combine = c) %dopar% {
  
  as.numeric(system(paste0("samtools view -c ", i), intern = T))
  
}

stopCluster(cl)

overall_summaries$finish_counts[match(c_d_names, overall_summaries$sample)] <- finish_read_counts

overall_summaries[, removed := read_counts - finish_counts]
overall_summaries[, read_counts := NULL]

overall_summaries <- melt.data.table(overall_summaries, id.vars = c("sample"))
overall_summaries <- overall_summaries[order(overall_summaries$variable, decreasing = T),]

read_filtering <- ggplot(overall_summaries, aes(x = sample, y = value, fill = variable)) +
  geom_bar(stat = "identity", position = "dodge") +
  ylab("Read Count") +
  xlab("Sample Origin") +
  scale_fill_manual("Read\nFiltering", values = c("#2ca9e1", "grey65"), labels = c("Read Kept", "Read Removed")) +
  coord_flip() +
  theme_minimal()



read_filtering <- read_filtering + theme(axis.title = element_text(size = 14),
                                         axis.text = element_text(size = 14))

title <- ggdraw() + 
  draw_label(
    paste0("Preprocessing Overview\nRead Filtering"),
    fontface = 'bold',
    x = 0,
    hjust = 0
  ) +
  theme(
    # add margin on the left of the drawing canvas,
    # so title is aligned with left edge of first plot
    plot.margin = margin(0, 0, 0, 7)
  )

read_filtering <- plot_grid(title, read_filtering, nrow = 2, rel_heights = c(0.1, 0.9))
  
cl <- makeCluster(min(threads, detectCores()))

registerDoParallel(cl)

coverage_and_depth <- foreach(i = 1:length(cov_depth), .packages = c("data.table")) %dopar% {
  tmp <- fread(cov_depth[i], sep = "\t")
  tmp[, source := c_d_names[i]]
}

stopCluster(cl)


#Making these legends later is a pain, doing it this way is easy.
color_legend_plot <- ggplot(data = data.table(dots = c(1,2,3)), aes(x = dots, fill = factor(dots))) +
  geom_bar()+
  scale_fill_manual(name = "Contig\nAssessment", values = alpha(c("grey65","#2ca9e1", "#FF0000"), 1), labels = c("Low Coverage", "Low Depth", "Passing Contig"))+
  theme(legend.text = element_text(size = 14),
        legend.title = element_text(size = 14))


color_leg <- get_legend(color_legend_plot)

#We have the data to plot hists of coverage/depth passing, and can show both reads passing and contigs passing.


create_summary_viz <- function(depth_data, file_name, file_size, cov=min_cov, depth=min_dep, leg = color_leg){
  
  group.colors <- c('Insufficient Coverage' = "grey65", 'Insufficient Depth' = "#2CA9E1", 'Passing Contig' = "#FF0000")
  
  depth_data$pass_level <- ifelse(depth_data$V3 >= cov, ifelse(depth_data$V4 >= depth, "Passing Contig", "Insufficient Depth"), "Insufficient Coverage")
  depth_data <- depth_data[order(depth_data$pass_level),]
  
  donut_TF <- depth_data
  donut_TF$coord <- seq(0, 1, length.out = nrow(donut_TF))

  #Quirk of geom_rect; if the data is left like so, it will plot a single rectangle for each row of data around the donut. 
  #This will result in visual artifacts, slow plotting speed, and massively oversized PDFs.
  
  donut_TF$ymax = cumsum(donut_TF$coord)
  donut_TF$ymin = c(0, head(donut_TF$ymax, n=-1))
  
  maxes <- donut_TF[, max(ymax, na.rm = T), by = pass_level]
  
  donut_TF <- donut_TF[match(c("Insufficient Coverage", "Insufficient Depth", "Passing Contig")[c("Insufficient Coverage", "Insufficient Depth", "Passing Contig") %in% donut_TF$pass_level], donut_TF$pass_level),]
  
  donut_TF$ymax[match(donut_TF$pass_level, maxes$pass_level)] <- maxes$V1
  
  donut_TF[,ymax:=-ymax]
  donut_TF[,ymin:=-ymin]
  
  title <- ggdraw() + 
    draw_label(
      paste0(file_name, "\nDepth and Coverage of Contigs"),
      fontface = 'bold',
      x = 0,
      hjust = 0
    ) +
    theme(
      # add margin on the left of the drawing canvas,
      # so title is aligned with left edge of first plot
      plot.margin = margin(0, 0, 0, 7)
    )
  
  #Produces a contig-level summary of passage by 
  overview_donut <- ggplot(donut_TF, aes(fill=pass_level, xmin=4.5, xmax=6, ymin=ymin, ymax=ymax))+
    geom_rect()+
    coord_polar(theta="y") +
    xlim(c(0, 6))+
    theme(panel.grid=element_blank(),axis.text=element_blank(),axis.ticks=element_blank(),axis.title=element_blank(), panel.background = element_blank()) +
    #annotate("text", x = 0, y = 0, label = file_name, size = 3) +
    annotate("text", x = 0.70, y = 0, label = paste("Original Contigs:", nrow(depth_data)),size = 3) +
    annotate("text", x = 0.20, y = 0, label = paste("Contigs with Passing Coverage and TAD:", sum(depth_data$pass_level == "Passing Contig")),size = 3) +
    labs(title="")+
    guides(fill=FALSE) +
    scale_fill_manual(values = group.colors)
  
  overview_donut <- plot_grid(NULL, overview_donut, leg, NULL, ncol = 4, rel_widths = c(.5, .85, .15, .3))
  
  overview_donut <- plot_grid(title, overview_donut, nrow = 2, rel_heights = c(0.1, 0.9))
  
  contig_breakdown <- ggplot(depth_data, aes(x = V3, y = V4, fill = pass_level)) +
                        geom_point(alpha = 0.6, shape = 21, color = "grey80", size = 4) +
                        geom_vline(xintercept = cov)+
                        geom_hline(yintercept = depth)+
                        theme_minimal() +
                        ylab("Truncated Average Sequencing Depth")+
                        xlab("Percent of Genome Covered")+
                        scale_fill_manual(values = group.colors)+
                        annotate("text", x = cov, y = Inf, label = paste("Minimum Coverage:", cov, " "), vjust=1, hjust = 1) +
                        annotate("text", x = Inf, y = depth*(19/20), label = paste("Minimum TAD:", depth), vjust = 1, hjust = 1) +
                        expand_limits(x = 0, y = 0)
  
  contig_breakdown <- contig_breakdown + theme(legend.position = "none",
                                               #axis.line = element_line("grey80"),
                                               axis.title = element_text(size = 14),
                                               axis.text = element_text(size = 14),
                                               panel.grid = element_line(colour = "grey80"))
  
  
  depth_boxplots <- ggplot(depth_data, aes(y = V4, fill = pass_level))+
                        geom_boxplot(outlier.color = "grey80", outlier.shape = 21, outlier.size = 4) +
                        scale_fill_manual(values = group.colors) +
                        ylab("Truncated Average Depth")+
                        xlab("")+
                        theme_minimal()+
                        expand_limits(y = 0)
  
  depth_boxplots <- depth_boxplots + theme(legend.position = "none", 
                                           axis.text = element_blank(), 
                                           #axis.title = element_blank(),
                                           axis.line.y = element_line("grey80"),
                                           axis.ticks = element_blank(),
                                           panel.grid = element_line(colour = "grey80"))
  
  cov_boxplots <- ggplot(depth_data, aes(y = V3, fill = pass_level))+
                    geom_boxplot(outlier.color = "grey80", outlier.shape = 21, outlier.size = 4) +
                    scale_fill_manual(values = group.colors) +
                    xlab("")+
                    ylab("Percent of Genome Covered") +
                    expand_limits(y = 0) +
                    theme_minimal()+
                    coord_flip()
  
  cov_boxplots <- cov_boxplots + theme(legend.position = "none", 
                                       axis.text = element_blank(), 
                                       #axis.title = element_blank(),
                                       axis.line.x = element_line("grey80"),
                                       axis.ticks = element_blank(),
                                       panel.grid = element_line(colour = "grey80"))
                
  
  
  c_d_plot <- plot_grid(cov_boxplots, NULL, contig_breakdown, depth_boxplots, ncol = 2, align = "hv", 
            rel_widths = c(3, 1), rel_heights = c(1, 3), axis = "xy")
  
  legend_plot <- plot_grid(NULL, leg, NULL, NULL, ncol = 2, 
                           rel_widths = c(3, 1), rel_heights = c(1, 4))
  
  c_d_plot <- ggdraw(c_d_plot) + draw_plot(legend_plot)
  
  c_d_plot <- plot_grid(
    title, c_d_plot,
    ncol = 1,
    # rel_heights values control vertical title margins
    rel_heights = c(0.1, 0.9)
  )
  
  return(list(overview_donut, c_d_plot))
    
}


pdf("MetaPop/12.Visualizations/preprocessing_summaries.pdf", width = 16, height = 9)

print(read_filtering)

for(i in 1:length(coverage_and_depth)){
  tmp <- create_summary_viz(coverage_and_depth[[i]], c_d_names[i], file.size(cov_depth[i]))
  print(tmp[[1]])
  print(tmp[[2]])
}

dev.off()

options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])

library_location <- options[3]

if(library_location == ""){
  library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Component specific
min_cov <- as.numeric(options[6])
min_dep <- as.numeric(options[7])

sub_samp <- as.numeric(options[8])


setwd(directory_name)



suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(stringr, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(Biostrings, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(Rsamtools, lib.loc = library_location)))



linked_snps <- fread("MetaPop/07.Cleaned_SNPs/genic_snps.tsv", sep = "\t")
linked_snps <- linked_snps[link == T,]


#Use this for cleaning out invalid codons containing Ns.
construct <- c("AAA", "AAT", "AAC", "AAG",
               "ATA", "ATT", "ATC", "ATG",
               "ACA", "ACT", "ACC", "ACG",
               "AGA", "AGT", "AGC", "AGG",
               
               "TAA", "TAT", "TAC", "TAG",
               "TTA", "TTT", "TTC", "TTG",
               "TCA", "TCT", "TCC", "TCG",
               "TGA", "TGT", "TGC", "TGG",
               
               "CAA", "CAT", "CAC", "CAG",
               "CTA", "CTT", "CTC", "CTG",
               "CCA", "CCT", "CCC", "CCG",
               "CGA", "CGT", "CGC", "CGG",
               
               "GAA", "GAT", "GAC", "GAG",
               "GTA", "GTT", "GTC", "GTG",
               "GCA", "GCT", "GCC", "GCG",
               "GGA", "GGT", "GGC", "GGG")

if(nrow(linked_snps)==0){
  
  print("There are no potentially linked snps in your data. This process is not applicable, but other steps will still function.")
  quit("no")
  
}

colnames(linked_snps) = c("contig_pos",	"contig",	"pos",	"ref_base",	"depth",	"a_ct",	"t_ct",	"c_ct",	"g_ct",	"source",	"snps",	"contig_gene",	"start",	"end",	"OC",	"codon",	"pos_in_codon",	"link")

#For this step, most of this data is useless. Removing it now is good.
linked_snps <- linked_snps[,c(1:4, 10:12, 15:17)]

#Order things for consistent behavior later
linked_snps <- linked_snps[order(source, contig_gene, OC, codon, pos),]

#Gather information into a wider format so that shaping to long is easier later

#Better group_by code
setkeyv(linked_snps, c("source", "contig_gene", "OC", "codon"))
collections <- linked_snps[, list(pos=list(pos), refs=list(ref_base), snps=list(snps), pos_in_codon=list(pos_in_codon)), by = key(linked_snps)]

# Based on the method of IDing putative linked SNPs, some false positives get through. This corrects that.
collections <- collections[lengths(collections$pos)>1,]

setkeyv(collections, c("source", "contig_gene", "OC", "codon"))

# Clean out the false positives here, too
linked_snps[, hasMatch := length(ref_base) > 1, by = key(linked_snps)]
linked_snps <- linked_snps[linked_snps$hasMatch,]
linked_snps[,hasMatch := NULL]

# no need to multi-read data
unique_codons <- unique(linked_snps, by = key(linked_snps))

# If it's original strand, the max pos. in genome is >= pos, by 2 is pos in codon = 1, 1 if 2, 0 if 3. 
#For the compliment, the max pos. in gen. is when the pos. in codon is 1, so we add when pos. in contig is 3 instead
unique_codons$max_pos <- ifelse(unique_codons$OC > 0, 
                                unique_codons$pos+(c(0,1,2)[match(unique_codons$pos_in_codon, c(3,2,1))]),
                                unique_codons$pos+(c(2,1,0)[match(unique_codons$pos_in_codon, c(3,2,1))]))

unique_codons$min_pos <- ifelse(unique_codons$OC > 0, 
                                unique_codons$pos-(c(0,1,2)[match(unique_codons$pos_in_codon, c(1,2,3))]),
                                unique_codons$pos-(c(2,1,0)[match(unique_codons$pos_in_codon, c(1,2,3))]))

unique_unique_sources <- unique(unique_codons$source)

# Extracts only the seqs from each sample which correspond to covering a region where a potentially linked snp might be occurring
# Then, processes the reads to extract the relevant codon (where it is actually found), and returns counts of each unique codon occurrence

# Pileup automatically considers read call quality in generating its counts. Typically, there will be a few more reads returned by this than the pileup indicates
cl <- makeCluster(min(detectCores(), threads, length(unique_unique_sources)))
registerDoParallel(cl)
clusterExport(cl=cl, c("library_location", "unique_codons", "unique_unique_sources", "construct"))
suppressMessages(clusterEvalQ(cl=cl, expr = suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))))
suppressMessages(clusterEvalQ(cl=cl, expr = suppressMessages(suppressWarnings(library(stringr, lib.loc = library_location)))))
suppressMessages(clusterEvalQ(cl=cl, expr = suppressMessages(suppressWarnings(library(Rsamtools, lib.loc = library_location)))))
suppressMessages(clusterEvalQ(cl=cl, expr = suppressMessages(suppressWarnings(library(Biostrings, lib.loc = library_location)))))


#Reverse complements are not being done here - this is strictly observing counts of occurrences of particular SNPs relative to their position in the genome according to the primary strand.
#The task of correcting these codons happens in microdiversity
readSets <- foreach(i=unique_unique_sources) %dopar% {
  
  subset <- unique_codons[unique_codons$source == i,]
  
  gr <- GRanges(seqnames = subset$contig, ranges = IRanges(start = subset$min_pos, end = subset$max_pos))
  
  param <- ScanBamParam(what = c("pos", "cigar", "seq"), which = gr)
  
  reads <- scanBam(paste("MetaPop/02.Filtered_Samples/", i, "_preprocessed.bam", sep = ""), param = param)
  
  #end N cleaning
  
  collected_reads <- lapply(1:length(reads), function(y){
      
      if(length(reads[[y]]$cigar) > 0){
      
      #The set of sequences without insertions or deletions
      easy_cases <- lengths(str_extract_all(reads[[y]]$cigar, "[A-Z]")) == 1
      
      #We need the +1 because this would end up zero-indexing the read, and R 1-indexes
      easy_subs <- substring(reads[[y]]$seq[easy_cases], subset$min_pos[y]-reads[[y]]$pos[easy_cases]+1, subset$max_pos[y]-reads[[y]]$pos[easy_cases]+1)
      
      #TODO - here would be where a rev-comp is done for a negative strand read
      
      #The way that reads are extracted, if the start is less than max_pos and the end is greater than min_pos, the reads comes in. This little cleanup takes care of that.
      easy_subs <- easy_subs[nchar(easy_subs) == 3]
      
      if(sum(!easy_cases) > 0){  
      hard_cases_cig <- reads[[y]]$cigar[!easy_cases]
      hard_cases_reads <- as.character(reads[[y]]$seq[!easy_cases])
      hard_cases_pos <- reads[[y]]$pos[!easy_cases]
      
      cigar_nums <- lapply(strsplit(hard_cases_cig, split = "[A-Z]"), as.numeric)
      cigar_letters <- lapply(strsplit(hard_cases_cig, split = "[0-9]+"), function(w){return(w[2:length(w)])})
      
      hard_subs <- mapply(function(min_pos, read, pos, nums, letters){
        
        #These are the positions, relative to the start of the read, that need returned
        pulls <- (min_pos-pos+1):(min_pos-pos+3)
        
        #expands the cigar string into a sequence of letters matching the counts of each subsequent cigar match
        cig_by_pos <- rep(letters, times=nums)
        
        #Actual read bases are either a match or an insertion. This is the set that matches those
        matches_read <- cig_by_pos[cig_by_pos == "M" | cig_by_pos == "I"]
        
        #This is the set of positions that contribute to the pos. in genome
        cig_by_pos <- cig_by_pos[cig_by_pos == "M"|cig_by_pos=="D"]
        
        #Reduce the read to matches only, at the correct positions
        split_read <- strsplit(read, split="")[[1]]
        split_read <- split_read[matches_read=="M"]
        
        #Get all the positions, no skips
        corrected_position <- 1:sum(nums[letters=="M"|letters=="D"])
        corrected_position <- corrected_position[cig_by_pos == "M"]
        
        
        read <- paste0(split_read[match(pulls, corrected_position)], collapse = "")
        
        return(read)
        
        
      }, subset$min_pos[y], hard_cases_reads, hard_cases_pos, cigar_nums, cigar_letters)
      
      #Same cleanup as before. This also handles cases where there was a deletion in the codon; 
      # functionally the codon is no longer operating in these cases, as a base is missing, and they should be excluded.
      hard_subs <- hard_subs[nchar(hard_subs) == 3]
      
      fullSet <- c(easy_subs, hard_subs)
      fullSet <- fullSet[fullSet %in% construct]
      
      # We only need the counts of each type of occurrence, not the full-fledged set.
      return(rle(sort(fullSet)))
      
      } else {
        
        # And if there are no hard cases, this is fine
        fullSet <- easy_subs
        fullSet <- fullSet[fullSet %in% construct]
        
        return(rle(sort(fullSet)))
        
      }
      
      } else {
        
        return(rle(integer(0)))
        
      }
      
      
      
    })
    
  return(collected_reads)
  
}

stopCluster(cl)

#Translate the list of lists returned by the above loop into a single list with the same length as the unique_codons - this is the raw data we're working from
readSets <- do.call(c, readSets)

# For each codon on the same gene/strand in linked_snps, there is a single reference base at each variant position, and between 1 and 3 snps.
# To be thorough, each pairwise combination of SNPs should be interrogated 
# - up to 27 comparisons if there are 3 snps at each position in a codon, though this is very unikely.

# For the pusposes of creating a readable file that is convenient for a user and for extracting data later, linked_snps is converted to a format where the reference codon is compared to a
# specific snp combination, per line. Thus, each pairwise combo takes up a single line.

ref_set <- function(refs, positions){
  
  if(length(refs)==3){
    return(paste0(refs, collapse=""))
  } else {
    
    if(all(positions == c(1, 3)) | all(positions == c(3,1))){
      
      return(paste0(refs[1], "*", refs[2], collapse = ""))
      
    }
    
    if( all(positions == c(1,2)) ){
      
      return(paste0(refs[1], refs[2], "*", collapse = ""))
      
    }
    
    if( all(positions == c(2,1)) ){
      
      return(paste0("*", refs[1], refs[2], collapse = ""))
      
    }
    
    if( all(positions == c(2,3)) ){
      
      return(paste0("*", refs[1], refs[2], collapse = ""))
      
    }
    
    if( all(positions == c(3,2)) ){
      
      return(paste0(refs[1], refs[2], "*", collapse = ""))
      
    }
    
  }
  
}

collections$refs <- mapply(ref_set, collections$refs, collections$pos_in_codon)

# Gets every combo of >= 2 snps on the same codon; for codons with 3 snps, this includes each subset of 2 snps
snp_expand <- function(snps, positions){
  
  if(length(snps) == 3){
    
    set1 <- strsplit(snps[1], split = "")[[1]]
    set2 <- strsplit(snps[2], split = "")[[1]]
    set3 <- strsplit(snps[3], split = "")[[1]]
    
    snps <- expand.grid(set1, set2, set3)
    
    snps <- c(paste0(snps$Var1, snps$Var2, snps$Var3),
              paste0("*", snps$Var2, snps$Var3),
              paste0(snps$Var1, "*", snps$Var3),
              paste0(snps$Var1, snps$Var2, "*"))
    
    return(list(snps))
    
  } else {
    
    set1 <- strsplit(snps[1], split = "")[[1]]
    set2 <- strsplit(snps[2], split = "")[[1]]
    snps <- expand.grid(set1, set2)
    
    if(all(positions == c(1, 3)) | all(positions == c(3,1))){
      
      snps <- paste0(snps$Var1, "*", snps$Var2)
      return(list(snps))
      
    }
    
    if( all(positions == c(1,2)) ){
      
      snps <- paste0(snps$Var1, snps$Var2, "*")
      return(list(snps))  
      
    }
    
    if( all(positions == c(2,1)) ){
      
      snps <- paste0("*",snps$Var1, snps$Var2)
      return(list(snps))
      
    }
    
    if( all(positions == c(2,3)) ){
      
      snps <- paste0("*",snps$Var1, snps$Var2)
      return(list(snps))
      
    }
    
    if( all(positions == c(3,2)) ){
      
      snps <- paste0(snps$Var1, snps$Var2, "*")
      return(list(snps))  
      
    }
    
    
  }
  
}

flattened_snps <- mapply(snp_expand, collections$snps, collections$pos_in_codon)

repetitions <- lengths(flattened_snps)

# This contains all the info needed to access the associated mined reads and perform a fisher's exact test on each set of candidate linked SNPs
long_snp_table <- data.table(data_ref = rep(1:length(readSets), times = repetitions),
                             source = rep(collections$source, times = repetitions),
                             contig_gene = rep(collections$contig_gene, times = repetitions),
                             OC = rep(collections$OC, times = repetitions),
                             codon = rep(collections$codon, times = repetitions),
                             refs = rep(collections$refs, times = repetitions),
                             snp = unlist(flattened_snps))

# lots of data we no longer need
rm(linked_snps, collections, unique_codons, unique_unique_sources)

#Occasionally mining snps will produce no reads covering the spot. This is OK, but must be cleaned
lacking_data <- which(unlist(lapply(readSets, function(x){length(x$values)>0})))

#We don't want to mess with the reference mined reads, because this would require further correction. Instead, the empty indices are simply skipped.
long_snp_table <- long_snp_table[long_snp_table$data_ref %in% lacking_data,]

match_ref <- strsplit(long_snp_table$refs, split = "")
match_snp <- strsplit(long_snp_table$snp, split = "")

calculate_linkage <- function(data_index, split_ref, split_snp, strand){
  
  #Get the associated data
  data <- readSets[[data_index]]
  
  if(strand < 0){
    data$values <- lapply(data$values, function(x){
        
        reversed <- intToUtf8(rev(utf8ToInt(x)))
        complemented <- chartr("ATCG", "TAGC", reversed)
        
        return(complemented)
    })  
  }
  
  # transform it into a form that matches the test ref/snps
  data$values <- lapply(data$values, function(x){return(strsplit(x, split="")[[1]])})
  
  #Check for 3 snp case
  if(sum(split_ref == "*") == 0){
    
    #Convenience
    total <- sum(data$lengths)
    
    all_ref <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return(all(x == split_ref))
    })))])
    all_snp <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return(all(x == split_snp))
    })))])
    
    if(length(all_ref)==0){all_ref <- 0}
    if(length(all_snp)==0){all_snp <- 0}
    
    # randomize whether an odd count of off-diag cases will favor top right or bottom left in contingency table.
    randomizer <- (runif(1,0,1) > .5)
    
    #There's not a good way to do this with 3; this is a worst-case scenario for demonstrating linkage
    off_diag <- total-(all_ref+all_snp)
    
    first_is_ref <- ifelse(randomizer, floor(off_diag/2), ceiling(off_diag/2))
    second_is_ref <- off_diag-first_is_ref
    
    
  } else {
  
    
    all_ref <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return(sum(x == split_ref)==2)
    })))])
    all_snp <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return(sum(x == split_snp)==2)
    })))])
    
    if(length(all_ref)==0){all_ref <- 0}
    if(length(all_snp)==0){all_snp <- 0}
    
    # for the comparison of first ref/second ref, knowing where the star is matters
    missing <- which(split_ref == "*")
    
    if(missing == 1){first_place=2; second_place=3}
    if(missing == 2){first_place=1; second_place=3}
    if(missing == 3){first_place=1; second_place=2}
  
    
    first_is_ref <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return((x[first_place] == split_ref[first_place] & x[second_place] == split_snp[second_place]))
    })))])
    second_is_ref <- sum(data$lengths[which(unlist(lapply(data$values, function(x){
      return((x[first_place] == split_snp[first_place] & x[second_place] == split_ref[second_place]))
    })))])
    
    if(length(first_is_ref)==0){first_is_ref <- 0}
    if(length(second_is_ref)==0){second_is_ref <- 0}
    
  }
  


  return(matrix(c(all_ref, all_snp, first_is_ref, second_is_ref), nrow=1))
  
}

linkage_results <- data.table(t(mapply(calculate_linkage, long_snp_table$data_ref, match_ref, match_snp, long_snp_table$OC)))
names(linkage_results) = c("ref_count", "snp_count", "ref_first", "ref_second")

long_snp_table <- cbind(long_snp_table, linkage_results)

linkage_test <- function(all_ref, second_is_ref, first_is_ref, all_snp){

  contingency_table <- matrix(c(all_ref, second_is_ref, first_is_ref, all_snp), nrow = 2, ncol = 2)
  
  if(any(contingency_table < 0)){
	return(list(NA, NA))
  }


  p <- fisher.test(contingency_table)$p
  top <- (all_ref*all_snp)-(second_is_ref*first_is_ref)
  botA <- sqrt(all_ref+first_is_ref)
  botB <- sqrt(all_ref+second_is_ref)
  botC <- sqrt(all_snp+first_is_ref)
  botD <- sqrt(all_snp+second_is_ref)
  botDiv <- botA*botB*botC*botD
  
  phi <- top/botDiv
  
  return(list(p, phi))
  
}

linkage_results <- mapply(linkage_test, long_snp_table$ref_count, long_snp_table$ref_second, long_snp_table$ref_first, long_snp_table$snp_count)

long_snp_table$fisher_p <- unlist(linkage_results[c(T,F)])
long_snp_table$phi_coef <- unlist(linkage_results[c(F,T)])

long_snp_table <- long_snp_table[!is.na(long_snp_table$fisher_p),]

#test this
long_snp_table[, three_snps := grepl("*", snp)]

fwrite(long_snp_table, "MetaPop/09.Linked_SNPs/linked_snp_results.tsv", sep = "\t")

options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])
library_location <- options[3]

if(library_location == ""){
  library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Component specific
min_cov <- as.numeric(options[6])
min_dep <- as.numeric(options[7])

sub_samp <- as.numeric(options[8])

plot_all <- options[9]

if(plot_all == "1"){
  plot_all <- T
}else{
  plot_all <- F
}

snp_scale <- options[10]

setwd(directory_name)


get_names_and_lengths_from_fasta <- function(file){
  
  original_assemblies <- readLines(file)
  
  header_lines = substr(original_assemblies, 1, 1) == ">"
  
  seq_ids = original_assemblies[header_lines]
  
  char_counts = nchar(original_assemblies)
  #char_counts[header_lines] = 0
  
  rm(original_assemblies)
  
  lengths = rep(0, sum(header_lines))
  
  current_length = 0
  headers_count = 1
  
  for(i in 2:length(header_lines)){
    if(header_lines[i]){
      lengths[headers_count] = current_length
      headers_count = headers_count + 1
      current_length = 0
    }else{
      current_length = current_length + char_counts[i]
    }
    
  }
  
  #Final iter
  lengths[headers_count] = current_length
  
  
  seq_ids =  substr(seq_ids, 2, nchar(seq_ids ))
  
  seq_ids  <- unlist(lapply(seq_ids , function(x){
    
    res  = strsplit(x, split = ' ')[[1]]
    if(length(res) > 1){
      res = res[1]
    }
    
    return(res)
    
  }))
  
  result = data.table(seq_ids, lengths)
  
  return(result)
  
}

#suppressMessages(suppressWarnings(library(Biostrings, lib.loc = library_location)))

suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(gggenes, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(cowplot, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(RColorBrewer, lib.loc = library_location)))

# SNP positions in codons code

codon_pos_count <- fread("MetaPop/10.Microdiversity/global_codon_position_summary.tsv", sep = "\t")

codon_pos_count <- codon_pos_count[, list(sum(first_pos), sum(second_pos), sum(third_pos)), by = source]

codon_pos_count_all <- melt.data.table(codon_pos_count, id.vars = c("source"))
codon_pos_count_all <- codon_pos_count_all[, sum(value), by = source]

p_all <- ggplot(codon_pos_count_all, aes(x = source, y = V1)) +
  geom_bar(stat = "identity", position = "stack") +
  ylab("Count of SNPs in sample") +
  xlab("Sample of origin") +
  theme_minimal() +
  theme(axis.text.x = element_text(angle = 90), 
        axis.title.x = element_blank(),
        axis.title = element_text(size = 16),
        axis.text.y = element_text(size = 14),
        axis.line = element_line("black"),
        axis.ticks.y = element_line("black"),
        legend.title = element_text(size = 16),
        legend.text = element_text(size = 14))+
  scale_y_continuous(labels = scales::comma)


codon_pos_count[, sum := V1+V2+V3,]

codon_pos_count[, V1 := V1/sum]
codon_pos_count[, V2 := V2/sum]
codon_pos_count[, V3 := V3/sum]

codon_pos_count[, sum := NULL]

colnames(codon_pos_count)[2:4] = c("First Pos.", "Second Pos.", "Third Pos.")

codon_pos_count <- melt.data.table(codon_pos_count, id.vars = c("source"))

p <- ggplot(codon_pos_count, aes(x = source, y = value, fill = variable)) +
  geom_bar(stat = "identity", position = "stack") +
  ylab("Proportion of SNPs by position in codon") +
  xlab("Sample of origin") +
  theme_minimal() +
  scale_fill_manual("Position\nof SNP in\nCodon", labels = c("Pos. 1", "Pos. 2", "Pos. 3"), values = c("grey50", "#2ca9e1", "#FF0000")) + 
  theme(axis.text.x = element_text(angle = 90), 
        axis.title.x = element_blank(),
        axis.title = element_text(size = 16),
        axis.text.y = element_text(size = 14),
        axis.line = element_line("black"),
        axis.ticks.y = element_line("black"),
        legend.title = element_text(size = 16),
        legend.text = element_text(size = 14))




pdf("MetaPop/12.Visualizations/Third_Pos_SNP_summary.pdf", 11, 11)

print(p)

print(p_all)

dev.off()

#FST
if(file.exists("MetaPop/10.Microdiversity/fixation_index.tsv")){
  
fixation_data <- fread("MetaPop/10.Microdiversity/fixation_index.tsv", sep = "\t")
fixation_data_filtered <- fixation_data[!is.na(fixation_data$fst),]
contigs_names <- unique(fixation_data_filtered$contig)


namesave = unique(fixation_data_filtered$contig)
fixation_data <- fixation_data_filtered[, list(list(.SD)), by = contig]$V1

cl <- makeCluster(min(threads, detectCores()))
clusterExport(cl, varlist = c("library_location", "fixation_data"), envir = environment())
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))

registerDoParallel(cl)

fixation_data <- foreach(x = 1:length(fixation_data)) %dopar% {
  x <- fixation_data[[x]]
  
  tmp_contigs <- unique(c(x$row_samp, x$col_samp))
  
  x2 <- x[, list(col_samp, row_samp, fst) ]
  colnames(x2)[1:2] = c("row_samp", "col_samp")
  
  missing <- data.table(row_samp = tmp_contigs, col_samp = tmp_contigs, fst = 0)
  
  x <- rbind(x, x2, missing)
  
  organize_rows_and_cols <- sort(unique(c(x$row_samp, x$col_samp)))
  
  x$row_samp <- factor(x$row_samp, levels = organize_rows_and_cols)
  x$col_samp <- factor(x$col_samp, levels = organize_rows_and_cols)
  
  #Silly, but works as a method of ensuring that the plotting output is correct in shape.
  x2 <- dcast(x, col_samp ~ row_samp, value.var ="fst")
  rownames(x2) = x2$col_samp
  x2[, col_samp := NULL]
  
  x2[upper.tri(x2)] <- NA
  
  x2[, col_samp := rownames(x2)]
  
  x <- melt.data.table(x2, na.rm = T, id.vars = c("col_samp"))
  
  colnames(x)[2:3] = c("row_samp", "fst")
  
  
  return(x)
}

stopCluster(cl)


names(fixation_data) = namesave

groups <- (1:length(fixation_data))%/%threads
unique_groups <- unique(groups)

cl <- makeCluster(min(threads, detectCores()))
clusterExport(cl, varlist = c("library_location", "groups", "unique_groups"), envir = environment())
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location))))
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(RColorBrewer, lib.loc = library_location))))
registerDoParallel(cl)

pdf("MetaPop/12.Visualizations/fst_genome_heatmap_plots.pdf", width = 17, height = 11)

for(k in unique_groups){
  
  heatmaps <- foreach(i = fixation_data[groups==k], j = names(fixation_data)[groups==k]) %dopar% {
    
    fst_heatmap <- ggplot(i, aes(y = row_samp, x = col_samp, fill = fst))+
      geom_raster()+
      theme_classic()+
      theme(plot.title = element_text(size = 18, face = "bold"),
            axis.text.x = element_text(angle = 90, hjust = 0.5),
            axis.text.y = element_text(vjust = 0.5),
            plot.margin = unit(c(0,0,0,0), "cm"),
            legend.title = element_text(size = 16),
            legend.text = element_text(size = 14))+ 
      ylab("")+
      xlab("")+
      ggtitle(j)+
      scale_fill_gradient2(low = "#2ca9e1", mid="grey80", high="#ff0000", na.value = "black", midpoint = 0.5, limits= c(0,1))+
      guides(fill = guide_legend(title = "Fst"))
    
    return(fst_heatmap)
    
  }
  
  for(i in heatmaps){
    print(i)
  }
  
}

stopCluster(cl)

dev.off()

}
#main genomes


parse_genes = function(file){
  
  genes <- readLines(file)
  
  headers = substr(genes, 1, 1) == ">"
  
  genes = genes[headers]
  genes = substr(genes, 2, nchar(genes))
  
  s <- strsplit(genes, "[# \t]+") # split names by tab/space
  genes <- data.table(matrix(unlist(s), ncol=5, byrow=T))
  
  names(genes)[1:4] = c("contig_gene", "start", "end", "OC")
  
  genes$start <- as.numeric((genes$start))
  genes$end <- as.numeric((genes$end))
  
  genes <- genes[,-5]
  
  genes$parent_contig <- gsub("_\\d+$", "", genes$contig_gene)
  
  return(genes)
  
}

if(snp_scale=="local" | snp_scale == "both"){
  
  print("Creating local scale SNP plots...")

  genes = parse_genes(ref_genes)
  

gene_microdiv <- fread("MetaPop/10.Microdiversity/local_gene_microdiversity.tsv", sep = "\t")

gene_microdiv$parent_contig <- gsub("_\\d+$", "", gene_microdiv$contig_gene)

setkeyv(gene_microdiv, c("parent_contig", "source"))

if(!plot_all){
highest_selected_contigs <- gene_microdiv[, valuable <- sum(pNpS_ratio > 1, na.rm = T), by = key(gene_microdiv)]
highest_selected_contigs <- highest_selected_contigs[order(highest_selected_contigs$source, V1),]
retained_contigs <- unique(highest_selected_contigs[, tail(parent_contig, 3), by = source]$V1)
gene_microdiv <- gene_microdiv[gene_microdiv$parent_contig %in% retained_contigs,]
}

num_src <- length(unique(gene_microdiv$source))

genes <- genes[genes$parent_contig %in% gene_microdiv$parent_contig,]

genes$OC <- as.numeric(genes$OC)
reverser <- genes[,list(start = ifelse(OC < 0, end, start), end = ifelse(OC < 0, start, end))]
genes$start <- reverser$start
genes$end <- reverser$end
rm(reverser)
genes$pnps <- NA
genes$pi <- NA
genes$theta <- NA
genes$tajD <- NA
genes[, midpt := (start+end)/2]

unique_contigs <- genes[, list(list(.SD)), by = parent_contig]$V1
names(unique_contigs) = unique(genes$parent_contig)
rm(genes)


NS = unique(gene_microdiv$parent_contig)

gene_microdiv <- gene_microdiv[, list(list(.SD)), by = parent_contig]$V1
names(gene_microdiv) = NS
rm(NS)


fastaLengths = get_names_and_lengths_from_fasta(ref_fasta)
colnames(fastaLengths) = c("contig", "num_bases")


fastaLengths <- fastaLengths[ contig %in% names(gene_microdiv),]

fastaLengths[, bigness := round(log10(num_bases))]

setkey(fastaLengths, "bigness")


unique_contigs <- unique_contigs[fastaLengths$contig]


depth_info <- list.files(path = "MetaPop/04.Depth_per_Pos", full.names = T)
depth_names <- substr(depth_info, 26, nchar(depth_info)-20)


cl <- makeCluster(min(threads, detectCores()))

clusterExport(cl, varlist = c("library_location", "depth_info"), envir = environment())
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))

registerDoParallel(cl)

depth_bins <- foreach(x = depth_info) %dopar% {
  
  tmp <- fread(x, sep = "\t", header = F)
  colnames(tmp) = c("contig", "pos", "depth")
  tmp[,pos := ((pos %/% 250))*250,]
  
  setkeyv(tmp, c("contig", "pos"))
  contig_names <- unique(tmp$contig)
  
  tmp <- tmp[, sum(depth)/250, by = key(tmp)]
  
}

stopCluster(cl)

names(depth_bins) = depth_names


size_category <- fastaLengths[, list(list(contig)), by = bigness]



#Tajima's D plot needs a legend to specify the annotations, but without coloring the points. The easiest way to do this is to make a fake one and save it for later.
taj_d_legend_plot <- ggplot(data = data.table(dots = c(1,2,3)), aes(x = dots, fill = factor(dots))) +
  geom_bar()+
  scale_fill_manual(name = "Tajima's D\nSelection", values = alpha(c("red","grey50", "lightblue"), 0.35), labels = c("Positive", "Neutral", "Purifying"))+
  theme(legend.text = element_text(size = 14),
        legend.title = element_text(size = 14))
  

taj_d_legend <- get_legend(taj_d_legend_plot)



cl <- makeCluster(min(detectCores(), threads, length(unique_contigs)))

clusterExport(cl, varlist = c("library_location", "depth_info", "depth_names", "depth_bins"))

clusterEvalQ(cl, library(data.table, lib.loc = library_location))
clusterEvalQ(cl, library(ggplot2, lib.loc = library_location))
clusterEvalQ(cl, library(gggenes, lib.loc = library_location))
clusterEvalQ(cl, library(cowplot, lib.loc = library_location))


registerDoParallel(cl)

for(z in size_category$bigness){
  
  current_conts <- unlist(size_category$V1[size_category$bigness == z])
  
  groups <- (1:length(current_conts)) %/% threads
  unique_groups <- unique(groups)
  
pdf(paste0("MetaPop/12.Visualizations/local_contigs_bp_cat_",as.character(format(10^z, scientific = F)),"_microdiversity_viz.pdf"), width = 13 + (2^(z+1)), height = 11)
  
  for(k in unique_groups){

    all_contigs <- foreach(i = 1:length(unique_contigs[current_conts][groups == k])) %dopar% {
      
      name <- names(unique_contigs[current_conts][groups == k])[i]
      sub <- unique_contigs[[name]]
      sub_data <- gene_microdiv[[name]]
      
      full_len <- fastaLengths[contig == name, num_bases]
      
      #Extremely high pNpS is largely irrelevant to answering the question of selection. This fix keeps scaling consistent, but always displays high pNpS as pos. select.
      sub_data$pNpS_ratio <- ifelse(sub_data$pNpS_ratio > 2, 2, sub_data$pNpS_ratio)
      sub_data$pNpS_ratio <- ifelse(!sub_data$snps_present, 0, sub_data$pNpS_ratio)
      
      a_contig <- lapply(unique(sub_data$source), function(j){
        
        depth_dat <- depth_bins[[j]][depth_bins[[j]]$contig == name,]
        
        missing_bins <- seq(0, full_len, by = 250)
        missing_bins <- missing_bins[!missing_bins %in% depth_dat$pos]
        
        if(length(missing_bins) > 0){
          missing_bins <- data.table(contig = name, pos = missing_bins, V1 = 0)
          depth_dat <- rbind(depth_dat, missing_bins) 
        }
        
        sub$pnps[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$pNpS_ratio[sub_data$source == j]
        sub$pi[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$pi[sub_data$source == j]
        sub$theta[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$theta[sub_data$source == j]
        sub$tajD[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$taj_D[sub_data$source == j]
        
        pnps_fill <- any(!is.na(sub$pnps))
        pi_fill <- any(!is.na(sub$pi))
        theta_fill <- any(!is.na(sub$theta))
        tajD_fill <- any(!is.na(sub$tajD))
        
        
        if(tajD_fill){
          sub[is.infinite(tajD), tajD := NA]
        }
        
        labs <- c("Purifying (0)", "Neutral (1)", "Positive (>1)")
        
        brk <- c(0, 1, 2)
        
        genes_plot <- ggplot(sub, aes(fill=pnps, xmin = start, xmax = end, y = OC/2)) +
          geom_gene_arrow() +
          xlab("")+
          ylab("Strand") +
          scale_x_continuous(expand = c(0,0), labels = scales::comma)+
          scale_y_continuous(breaks = c(-0.5, 0.5), labels = c("-", "+"), limits = c(-.75, 0.75)) +
          scale_fill_gradient2(low="lightblue", mid = "white", high="red", na.value="black", breaks = brk, labels = labs, name = "pN/pS Ratio", limits = c(0, 2), midpoint = 1)+
          theme_genes() +
          ggtitle("pN/pS Selection by Gene")+
          theme(axis.text.y = element_text(size = 20, vjust = 0.38),
                axis.title.y = element_text(size = 16),
                axis.text.x = element_text(size = 14),
                legend.text = element_text(size = 14),
                legend.title = element_text(size = 14),
                title = element_text(size = 14)) + 
          scale_color_manual(values = 'black', labels = 'No pNpS') +
          guides(color = guide_legend(override.aes = list(fill = "black")))
        #Adds in pi, theta, and tajima's D points. Offset by their section of the plot.
        
        gene_legend <- get_legend(genes_plot)
        
        genes_plot <- genes_plot + theme(legend.position = "none",
                                         axis.line.x.bottom = element_line("black"))
        
        depth_by_pos_plot <- ggplot(depth_dat, aes(x = pos, y = V1))+
          geom_step() +
          theme_minimal()+
          ylab("Depth of Coverage")+
          xlab("") +
          scale_x_continuous(expand = c(0,0), labels = scales::comma)+
          ggtitle("Avg. Depth of Coverage over Contig")+
          theme(axis.title.y = element_text(size = 16),
                axis.text.x = element_text(size = 14),
                axis.line = element_line("black"),
                title = element_text(size = 14),
                axis.ticks = element_line("black"))
        
        thet_dat <- melt.data.table(sub, id.vars = "midpt", measure.vars = c("pi", "theta"))
        
        pi_and_theta_plot <- ggplot(thet_dat, aes(x = midpt, y = value, color = variable))+
          geom_point(size = 2) +
          theme_minimal() +
          xlab("")+
          ylab("Pi and Theta")+
          scale_x_continuous(expand = c(0,0), labels = scales::comma)+
          scale_color_manual("Nucleotide\nDiversity\nMeasure", labels = c("Pi", "Theta"), values = c("#af8dc3", "#7fbf7b")) +
          ggtitle("Pi and Theta Nucleotide Diversity by Gene")+
          theme(axis.title.y = element_text(size = 16),
                axis.text.x = element_text(size = 14),
                legend.text = element_text(size = 14),
                legend.title = element_text(size = 14),
                axis.line = element_line("black"),
                title = element_text(size = 14),
                axis.ticks = element_line("black"))
        
        thet_legend <- get_legend(pi_and_theta_plot)
        
        pi_and_theta_plot <- pi_and_theta_plot + theme(legend.position = "none")
        
        
        #Needs a fill legend for the colors.
        taj_d_plot <- ggplot(sub, aes(x = midpt))+
          geom_point(aes(y = tajD), size = 2) +
          theme_minimal() +
          xlab("")+
          scale_x_continuous(expand = c(0,0), labels = scales::comma)+
          ylab("Tajima's D") +
          ylim(c(min(sub$tajD), max(sub$tajD)))+
          annotate("rect", xmin = -Inf, xmax = Inf, ymin = -Inf, ymax = min(-2, max(sub$tajD)), fill = "lightblue", alpha = 0.35)+
          annotate("rect", xmin = -Inf, xmax = Inf, ymin = max(-2, min(sub$tajD)), ymax = min(2, max(sub$tajD)), fill = "grey50", alpha = 0.35)+
          annotate("rect", xmin = -Inf, xmax = Inf, ymin = max(2, min(sub$tajD)), ymax = Inf, fill = "red", alpha = 0.35) +
          ggtitle("Tajima's D Selection by Gene")+
          theme(axis.title.y = element_text(size = 16),
                axis.text.x = element_text(size = 14),
                legend.text = element_text(size = 14),
                legend.title = element_text(size = 14),
                axis.line = element_line("black"),
                title = element_text(size = 14),
                axis.ticks = element_line("black"))
        
        taj_d_plot <- taj_d_plot + theme(legend.position = "none")

        
        taj_d_plot <- taj_d_plot+ coord_cartesian(xlim = c(0,max(sub$end)))
        pi_and_theta_plot <- pi_and_theta_plot + coord_cartesian(xlim = c(0,max(sub$end)))
        depth_by_pos_plot <- depth_by_pos_plot+ coord_cartesian(xlim = c(0,max(sub$end)))
        genes_plot <- genes_plot + coord_cartesian(xlim = c(0,max(sub$end)))
        
        genes_plot <- plot_grid( depth_by_pos_plot,genes_plot, pi_and_theta_plot, taj_d_plot, align = "vh", ncol = 1, axis = "x")
        
        
        legends <- plot_grid(NULL, gene_legend, thet_legend, taj_d_legend, ncol = 1,nrow = 4, align = "vh")
        
        legend_area <- 0.1-(0.01 * z)
        
        title <- ggdraw() + 
          draw_label(
            paste("Contig:", name, "Sample:", j),
            fontface = 'bold',
            x = 0,
            hjust = 0
          ) +
          theme(
            # add margin on the left of the drawing canvas,
            # so title is aligned with left edge of first plot
            plot.margin = margin(0, 0, 0, 7)
          )
        
        genes_plot <- plot_grid(genes_plot, legends, ncol = 2, rel_widths = c(1-legend_area, legend_area))
        
        genes_plot <- ggdraw(add_sub(genes_plot, "Contig Position (bp)", vpadding=grid::unit(0,"lines"),y=6, x=0.5, vjust=4.5))
        
        genes_plot <- plot_grid(
          title, genes_plot,
          ncol = 1,
          # rel_heights values control vertical title margins
          rel_heights = c(0.07, 1)
        )
        
        
        return(genes_plot)
        
      })
      
      return(a_contig)
      
    }
    
    silent <- suppressWarnings(lapply(all_contigs, function(f){
      
      suppressWarnings(lapply(f, print))
      
      return(NA)
      
    }))
    
  }
  
dev.off()  

}

}


if(snp_scale=="global" | snp_scale == "both"){

  print("Creating global scale SNP plots...")
  
  genes = parse_genes(ref_genes)
  
  gene_microdiv <- fread("MetaPop/10.Microdiversity/global_gene_microdiversity.tsv", sep = "\t")
  
  gene_microdiv$parent_contig <- gsub("_\\d+$", "", gene_microdiv$contig_gene)
  
  setkeyv(gene_microdiv, c("parent_contig", "source"))
  
  if(!plot_all){
    highest_selected_contigs <- gene_microdiv[, valuable <- sum(pNpS_ratio > 1, na.rm = T), by = key(gene_microdiv)]
    highest_selected_contigs <- highest_selected_contigs[order(highest_selected_contigs$source, V1),]
    retained_contigs <- unique(highest_selected_contigs[, tail(parent_contig, 3), by = source]$V1)
    gene_microdiv <- gene_microdiv[gene_microdiv$parent_contig %in% retained_contigs,]
  }
  
  num_src <- length(unique(gene_microdiv$source))
  
  genes <- genes[genes$parent_contig %in% gene_microdiv$parent_contig,]
  
  genes$OC <- as.numeric(genes$OC)
  reverser <- genes[,list(start = ifelse(OC < 0, end, start), end = ifelse(OC < 0, start, end))]
  genes$start <- reverser$start
  genes$end <- reverser$end
  rm(reverser)
  genes$pnps <- NA
  genes$pi <- NA
  genes$theta <- NA
  genes$tajD <- NA
  genes[, midpt := (start+end)/2]
  
  unique_contigs <- genes[, list(list(.SD)), by = parent_contig]$V1
  names(unique_contigs) = unique(genes$parent_contig)
  rm(genes)
  
  
  NS = unique(gene_microdiv$parent_contig)
  
  gene_microdiv <- gene_microdiv[, list(list(.SD)), by = parent_contig]$V1
  names(gene_microdiv) = NS
  rm(NS)
  
  fastaLengths = get_names_and_lengths_from_fasta(ref_fasta)
  colnames(fastaLengths) = c("contig", "length")

  
  fastaLengths <- fastaLengths[ contig %in% names(gene_microdiv),]
  
  fastaLengths[, bigness := round(log10(num_bases))]
  
  setkey(fastaLengths, "bigness")
  
  
  unique_contigs <- unique_contigs[fastaLengths$contig]
  
  
  depth_info <- list.files(path = "MetaPop/03.Breadth_and_Depth", full.names = T)
  depth_names <- substr(depth_info, 30, nchar(depth_info)-22)
  
  
  cl <- makeCluster(min(threads, detectCores()))
  
  clusterExport(cl, varlist = c("library_location", "depth_info"), envir = environment())
  clusterEvalQ(cl, suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))
  
  registerDoParallel(cl)
  
  depth_bins <- foreach(x = depth_info) %dopar% {
    
    tmp <- fread(x, sep = "\t")
    colnames(tmp) = c("contig", "pos", "depth")
    tmp[,pos := ((pos %/% 250))*250,]
    
    setkeyv(tmp, c("contig", "pos"))
    contig_names <- unique(tmp$contig)
    
    tmp <- tmp[, sum(depth)/250, by = key(tmp)]
    
  }
  
  stopCluster(cl)
  
  names(depth_bins) = depth_names
  
  
  size_category <- fastaLengths[, list(list(contig)), by = bigness]
  
  
  
  #Tajima's D plot needs a legend to specify the annotations, but without coloring the points. The easiest way to do this is to make a fake one and save it for later.
  taj_d_legend_plot <- ggplot(data = data.table(dots = c(1,2,3)), aes(x = dots, fill = factor(dots))) +
    geom_bar()+
    scale_fill_manual(name = "Tajima's D\nSelection", values = alpha(c("red","grey50", "lightblue"), 0.35), labels = c("Positive", "Neutral", "Purifying"))+
    theme(legend.text = element_text(size = 14),
          legend.title = element_text(size = 14))
  
  
  taj_d_legend <- get_legend(taj_d_legend_plot)
  

  
  cl <- makeCluster(min(detectCores(), threads, length(unique_contigs)))
  
  clusterExport(cl, varlist = c("library_location", "groups", "unique_groups", "depth_info", "depth_names", "depth_bins"))
  
  clusterEvalQ(cl, library(data.table, lib.loc = library_location))
  clusterEvalQ(cl, library(ggplot2, lib.loc = library_location))
  clusterEvalQ(cl, library(gggenes, lib.loc = library_location))
  clusterEvalQ(cl, library(cowplot, lib.loc = library_location))
  
  
  registerDoParallel(cl)
  
  for(z in size_category$bigness){
    
    current_conts <- unlist(size_category$V1[size_category$bigness == z])
    
    groups <- (1:length(current_conts)) %/% threads
    unique_groups <- unique(groups)
    
    pdf(paste0("MetaPop/12.Visualizations/global_contigs_bp_cat_",as.character(format(10^z, scientific = F)),"_microdiversity_viz.pdf"), width = 13 + (2^(z+1)), height = 11)
    
    for(k in unique_groups){
      
      all_contigs <- foreach(i = 1:length(unique_contigs[current_conts][groups == k])) %dopar% {
        
        name <- names(unique_contigs[current_conts][groups == k])[i]
        sub <- unique_contigs[[name]]
        sub_data <- gene_microdiv[[name]]
        
        full_len <- fastaLengths[contig == name, num_bases]
        
        #Extremely high pNpS is largely irrelevant to answering the question of selection. This fix keeps scaling consistent, but always displays high pNpS as pos. select.
        sub_data$pNpS_ratio <- ifelse(sub_data$pNpS_ratio > 2, 2, sub_data$pNpS_ratio)
        sub_data$pNpS_ratio <- ifelse(!sub_data$snps_present, 0, sub_data$pNpS_ratio)
        
        a_contig <- lapply(unique(sub_data$source), function(j){
          
          depth_dat <- depth_bins[[j]][depth_bins[[j]]$contig == name,]
          
          missing_bins <- seq(0, full_len, by = 250)
          missing_bins <- missing_bins[!missing_bins %in% depth_dat$pos]
          
          if(length(missing_bins) > 0){
            missing_bins <- data.table(contig = name, pos = missing_bins, V1 = 0)
            depth_dat <- rbind(depth_dat, missing_bins) 
          }
          
          sub$pnps[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$pNpS_ratio[sub_data$source == j]
          sub$pi[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$pi[sub_data$source == j]
          sub$theta[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$theta[sub_data$source == j]
          sub$tajD[match(sub_data$contig_gene[sub_data$source == j], sub$contig_gene)] <- sub_data$taj_D[sub_data$source == j]
          
          pnps_fill <- any(!is.na(sub$pnps))
          pi_fill <- any(!is.na(sub$pi))
          theta_fill <- any(!is.na(sub$theta))
          tajD_fill <- any(!is.na(sub$tajD))
          
          
          if(tajD_fill){
            sub[is.infinite(tajD), tajD := NA]
          }
          
          labs <- c("Purifying (0)", "Neutral (1)", "Positive (>1)")
          
          brk <- c(0, 1, 2)
          
          genes_plot <- ggplot(sub, aes(fill=pnps, xmin = start, xmax = end, y = OC/2)) +
            geom_gene_arrow() +
            xlab("")+
            ylab("Strand") +
            scale_x_continuous(expand = c(0,0), labels = scales::comma)+
            scale_y_continuous(breaks = c(-0.5, 0.5), labels = c("-", "+"), limits = c(-.75, 0.75)) +
            scale_fill_gradient2(low="lightblue", mid = "white", high="red", na.value="black", breaks = brk, labels = labs, name = "pN/pS Ratio", limits = c(0, 2), midpoint = 1)+
            theme_genes() +
            ggtitle("pN/pS Selection by Gene")+
            theme(axis.text.y = element_text(size = 20, vjust = 0.38),
                  axis.title.y = element_text(size = 16),
                  axis.text.x = element_text(size = 14),
                  legend.text = element_text(size = 14),
                  legend.title = element_text(size = 14),
                  title = element_text(size = 14)) + 
            scale_color_manual(values = 'black', labels = 'No pNpS') +
            guides(color = guide_legend(override.aes = list(fill = "black")))
          #Adds in pi, theta, and tajima's D points. Offset by their section of the plot.
          
          gene_legend <- get_legend(genes_plot)
          
          genes_plot <- genes_plot + theme(legend.position = "none",
                                           axis.line.x.bottom = element_line("black"))
          
          depth_by_pos_plot <- ggplot(depth_dat, aes(x = pos, y = V1))+
            geom_step() +
            theme_minimal()+
            ylab("Depth of Coverage")+
            xlab("") +
            scale_x_continuous(expand = c(0,0), labels = scales::comma)+
            ggtitle("Avg. Depth of Coverage over Contig")+
            theme(axis.title.y = element_text(size = 16),
                  axis.text.x = element_text(size = 14),
                  axis.line = element_line("black"),
                  title = element_text(size = 14),
                  axis.ticks = element_line("black"))
          
          thet_dat <- melt.data.table(sub, id.vars = "midpt", measure.vars = c("pi", "theta"))
          
          pi_and_theta_plot <- ggplot(thet_dat, aes(x = midpt, y = value, color = variable))+
            geom_point(size = 2) +
            theme_minimal() +
            xlab("")+
            ylab("Pi and Theta")+
            scale_x_continuous(expand = c(0,0), labels = scales::comma)+
            scale_color_manual("Nucleotide\nDiversity\nMeasure", labels = c("Pi", "Theta"), values = c("#af8dc3", "#7fbf7b")) +
            ggtitle("Pi and Theta Nucleotide Diversity by Gene")+
            theme(axis.title.y = element_text(size = 16),
                  axis.text.x = element_text(size = 14),
                  legend.text = element_text(size = 14),
                  legend.title = element_text(size = 14),
                  axis.line = element_line("black"),
                  title = element_text(size = 14),
                  axis.ticks = element_line("black"))
          
          thet_legend <- get_legend(pi_and_theta_plot)
          
          pi_and_theta_plot <- pi_and_theta_plot + theme(legend.position = "none")
          
          
          #Needs a fill legend for the colors.
          taj_d_plot <- ggplot(sub, aes(x = midpt))+
            geom_point(aes(y = tajD), size = 2) +
            theme_minimal() +
            xlab("")+
            scale_x_continuous(expand = c(0,0), labels = scales::comma)+
            ylab("Tajima's D") +
            ylim(c(min(sub$tajD), max(sub$tajD)))+
            annotate("rect", xmin = -Inf, xmax = Inf, ymin = -Inf, ymax = min(-2, max(sub$tajD)), fill = "lightblue", alpha = 0.35)+
            annotate("rect", xmin = -Inf, xmax = Inf, ymin = max(-2, min(sub$tajD)), ymax = min(2, max(sub$tajD)), fill = "grey50", alpha = 0.35)+
            annotate("rect", xmin = -Inf, xmax = Inf, ymin = max(2, min(sub$tajD)), ymax = Inf, fill = "red", alpha = 0.35) +
            ggtitle("Tajima's D Selection by Gene")+
            theme(axis.title.y = element_text(size = 16),
                  axis.text.x = element_text(size = 14),
                  legend.text = element_text(size = 14),
                  legend.title = element_text(size = 14),
                  axis.line = element_line("black"),
                  title = element_text(size = 14),
                  axis.ticks = element_line("black"))
          
          taj_d_plot <- taj_d_plot + theme(legend.position = "none")
          
          
          taj_d_plot <- taj_d_plot+ coord_cartesian(xlim = c(0,max(sub$end)))
          pi_and_theta_plot <- pi_and_theta_plot + coord_cartesian(xlim = c(0,max(sub$end)))
          depth_by_pos_plot <- depth_by_pos_plot+ coord_cartesian(xlim = c(0,max(sub$end)))
          genes_plot <- genes_plot + coord_cartesian(xlim = c(0,max(sub$end)))
          
          genes_plot <- plot_grid( depth_by_pos_plot,genes_plot, pi_and_theta_plot, taj_d_plot, align = "vh", ncol = 1, axis = "x")
          
          
          legends <- plot_grid(NULL, gene_legend, thet_legend, taj_d_legend, ncol = 1,nrow = 4, align = "vh")
          
          legend_area <- 0.1-(0.01 * z)
          
          title <- ggdraw() + 
            draw_label(
              paste("Contig:", name, "Sample:", j),
              fontface = 'bold',
              x = 0,
              hjust = 0
            ) +
            theme(
              # add margin on the left of the drawing canvas,
              # so title is aligned with left edge of first plot
              plot.margin = margin(0, 0, 0, 7)
            )
          
          genes_plot <- plot_grid(genes_plot, legends, ncol = 2, rel_widths = c(1-legend_area, legend_area))
          
          genes_plot <- ggdraw(add_sub(genes_plot, "Contig Position (bp)", vpadding=grid::unit(0,"lines"),y=6, x=0.5, vjust=4.5))
          
          genes_plot <- plot_grid(
            title, genes_plot,
            ncol = 1,
            # rel_heights values control vertical title margins
            rel_heights = c(0.07, 1)
          )
          
          
          return(genes_plot)
          
        })
        
        return(a_contig)
        
      }
      
      silent <- suppressWarnings(lapply(all_contigs, function(f){
        
        suppressWarnings(lapply(f, print))
        
        return(NA)
        
      }))
      
    }
    
    dev.off()  
    
  }
  
}

options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])
library_location <- options[3]

if(library_location == ""){
  library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Component specific
min_cov <- as.numeric(options[6])
min_dep <- as.numeric(options[7])


setwd(directory_name)

suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(Biostrings, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(cowplot, lib.loc = library_location)))



passing_contigs <- list.files(path = "MetaPop/03.Breadth_and_Depth", pattern = ".tsv", full.names = T)


cl <- makeCluster(min(detectCores(), threads, length(passing_contigs)))

clusterExport(cl, varlist=c("passing_contigs", "min_cov", "min_dep", "library_location"))
clusterEvalQ(cl, suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))

registerDoParallel(cl)

passing_contigs <- unique(foreach(i=passing_contigs, .combine=c) %dopar% {
  
  tmp <- fread(i, sep="\t", header = F)
  
  return(tmp$V1[tmp$V3>=min_cov & tmp$V4 >= min_dep])
  
})

stopCluster(cl)

#Already per contig
codon_bias_iqr <- fread(list.files(full.names = T, path = "MetaPop/08.Codon_Bias", pattern="gene_IQR_and_mean.tsv"), sep = "\t")
codon_bias_iqr <- codon_bias_iqr[codon_bias_iqr$parent_contig %in% passing_contigs,]

genes <- readDNAStringSet(ref_genes)

s <- strsplit(names(genes), "[# \t]+") # split names by tab/space
genes <- data.table(matrix(unlist(s), ncol=5, byrow=T))

names(genes)[1:4] = c("contig_gene", "start", "end", "OC")

genes$start <- as.numeric((genes$start))
genes$end <- as.numeric((genes$end))
genes <- genes[,-5]

# Figure out what contig they come from, mostly for cleaning purposes
genes$parent_contig <- gsub("_\\d+$", "", genes$contig_gene)  

genes <- genes[genes$parent_contig %in% passing_contigs,]

codon_bias_genes <- fread(list.files(full.names = T, path = "MetaPop/08.Codon_Bias", pattern="gene_euclidean_distances.tsv"), sep = "\t")
codon_bias_genes <- codon_bias_genes[codon_bias_genes$parent_contig %in% passing_contigs,]

codon_bias_genes$start <- genes$start[match(codon_bias_genes$gene, genes$contig_gene)]
codon_bias_genes$end <- genes$end[match(codon_bias_genes$gene, genes$contig_gene)]
codon_bias_genes$strand <- genes$OC[match(codon_bias_genes$gene, genes$contig_gene)]

rm(genes)

#presplit into contigs
namesave = unique(codon_bias_genes$parent_contig)
codon_bias_genes <- codon_bias_genes[, list(list(.SD)), by = parent_contig]$V1
names(codon_bias_genes) = namesave

codon_bias_genes <- lapply(codon_bias_genes, function(x){
  
  l <- min(x$euc_dist)
  u <- max(x$euc_dist)
  
  x$relative_dist <- 2+(((x$euc_dist - l)/(u-l))*2)
  
  return(x)
})

if(!all(passing_contigs %in% names(codon_bias_genes))){
  print("There's some contigs in the samples that weren't found in the genes file.")
  print("There may be cases where contigs had no predicted genes, or where the codon bias of a set of genes could not be calculated completely.")
  print("Only contigs with predicted genes can/will be plotted.")
  passing_contigs <- passing_contigs[passing_contigs %in% names(codon_bias_genes)]
}


#If I normalize the gene distance on 0-1, then I can make a consistent width plot

color_legend_plot <- ggplot(data = data.table(dots = c(1,2)), aes(x = dots, fill = factor(dots))) +
  geom_bar()+
  scale_fill_manual(name = "Gene Codon Bias", values = alpha(c("#2ca9e1", "#FF0000"), 1), labels = c("Typical Codon Use", "Abnormal Codon Use"))+
  theme(legend.text = element_text(size = 14),
        legend.title = element_text(size = 14))

color_leg <- get_legend(color_legend_plot)

codon_bias_ringplot <- function(contig, gene_profile, thresholds, leg = color_leg){
  #iqr <- round(thresholds[1], 2)
  #mu <- round(thresholds[2], 2)
  #outlier_bound <- round(thresholds[3], 2)
  
  if(all(thresholds == 0)){
    return(NA)
  }
  
  p <- ggplot(gene_profile, aes(fill=factor(outlier_status), xmin=2, xmax=relative_dist, ymin=start, ymax=end))+
    annotate("rect", xmin = 1.992, xmax = 4, ymin=0, ymax = max(gene_profile$end), fill = "grey65", color = "black") +
    geom_rect() +
    coord_polar(theta="y") +
    xlim(c(0, 4)) +
    ylim(c(0, max(gene_profile$end*4/3))) +
    theme(panel.background = element_blank(), 
          axis.text.y = element_blank(), 
          axis.title.y = element_blank(), 
          axis.ticks.y = element_blank(), 
          axis.text.x = element_blank(), 
          axis.title.x = element_blank(), 
          axis.ticks.x = element_blank(),
          axis.line = element_blank())+
    guides(fill = F) +
    ggtitle(paste0(contig, "\nCodon Usage Bias Distances")) +
    scale_fill_manual(values = c("#2ca9e1", "#FF0000")) +
    annotate("text", y = 0, x = 0, hjust = 0.5, label = paste("Contig Length\n", max(gene_profile$end), " bp", sep = ""), vjust = 0.5)+
    annotate("text", x = 3.1, y = max(gene_profile$end)*1.065, label = "Gene\nEuclidean\nDistance", vjust = 0, hjust = 0.5) +
    
    #tick labels
    annotate("text", y = max(gene_profile$end)*1.014, x = 4, label = paste0(round(max(gene_profile$euc_dist), 3), ""), vjust = 1, hjust = 0, angle = 90)+
    annotate("text", y = max(gene_profile$end)*1.030, x = 2, label = paste0(round(min(gene_profile$euc_dist), 3), ""), vjust = 0, hjust = 0, angle = 90)+
    
    #baseline
    #annotate("segment", x = 2, xend = 4, y = max(gene_profile$end)*1.025, yend = max(gene_profile$end)*1.014) +
    
    #ticks
    annotate("segment", x = 1.992, xend = 1.996, y = max(gene_profile$end), yend = max(gene_profile$end)*1.016) +
    annotate("segment", x = 2.66, xend = 2.66, y = max(gene_profile$end), yend = max(gene_profile$end)*1.012) +
    annotate("segment", x = 3.33, xend = 3.33, y = max(gene_profile$end), yend = max(gene_profile$end)*1.010) +
    annotate("segment", x = 4, xend = 4, y = max(gene_profile$end), yend = max(gene_profile$end)*1.008)
    
  
  p <- plot_grid(NULL, p, leg, NULL, ncol = 4, rel_widths = c(.3, .8, .15, .2))
  
  return(p)
  
}

groups <- (1:length(passing_contigs))%/%(min(threads, detectCores()))
unique_groups <- unique(groups)


cl <- makeCluster(min(threads, detectCores()))
clusterExport(cl, varlist = c("library_location", "groups", "unique_groups", "color_leg"), envir = environment())
clusterEvalQ(cl, expr = suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location))))
clusterEvalQ(cl, expr = suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location))))
clusterEvalQ(cl, expr = suppressMessages(suppressWarnings(library(cowplot, lib.loc = library_location))))

pdf("MetaPop/12.Visualizations/codon_bias_plots.pdf", height = 9, width = 12)

registerDoParallel(cl)

for(k in unique_groups){

CB_plots <- foreach(i = passing_contigs[groups == k]) %dopar% {
  
  codon_bias_ringplot(contig = i, gene_profile = codon_bias_genes[[which(names(codon_bias_genes) == i)]], thresholds =  as.numeric(codon_bias_iqr[which(codon_bias_iqr$parent_contig == i),2:4], leg = color_leg))
  
}

CB_plots <- CB_plots[!is.na(CB_plots)]

#prevents superfluous outputs
if(length(CB_plots) > 0){
for(i in CB_plots){
  print(i)
}
}

}

stopCluster(cl)

dev.off()

options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])
library_location <- options[3]

if(library_location == ""){
  library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Module specific 

coverage_cutoff <- as.numeric(options[6])
depth_cutoff <- as.numeric(options[7])

norm_file <- options[8]
whole_mag <- options[9]

if(whole_mag == "1"){
  whole_mag <- T
}else{
  whole_mag <- F
}


mag_cutoff <-as.numeric(options[10])

min_contig_length  <- as.numeric(options[11])

setwd(directory_name)

suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(stringr, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(ggplot2, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(cowplot, lib.loc = library_location)))

suppressMessages(suppressWarnings(library(ggrepel, lib.loc = library_location)))

suppressMessages(suppressWarnings(library(vegan, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(compositions, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(pheatmap, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(RColorBrewer, lib.loc = library_location)))

suppressMessages(suppressWarnings(library(bit64, lib.loc = library_location)))

cov_depth <- list.files(full.names = T, path = "MetaPop/03.Breadth_and_Depth")

#We just need the names, here
original_assemblies <- readLines(ref_fasta)
#Headers only.
original_assemblies <- original_assemblies[substr(original_assemblies, 1, 1) == ">"]

original_assemblies <- substr(original_assemblies, 2, nchar(original_assemblies))

original_assemblies <- unlist(lapply(original_assemblies, function(x){
  
  res  = strsplit(x, split = ' ')[[1]]
  if(length(res) > 1){
    res = res[1]
  }
  
  return(res)
  
}))



norm_header = fread(norm_file, header = T, sep = "\t")
norm_file <- fread(norm_file, header= F, sep = "\t")

if(ncol(norm_file) < 2 | ncol(norm_header) < 2){
  print("There's an error with the normalization file. MetaPop did not recognize the file as being a tab-separated, 2 column file with the first column being file names (minus final extension) and the second column being numbers.")
  print("Macrodiversity cannot proceed.")
  quit()
}

colnames(norm_file) = c("V1", "V2")
colnames(norm_header) = c("V1", "V2")

#If the norm file read without header isn't properly typed but the one read with a header is, then proceed with the header file.
if(!is.numeric(norm_file$V2) & is.numeric(norm_header$V2)){
  norm_file = norm_header
}


#Figures out the normalization factors on each sample.
norm_file$factor <- norm_file$V2/max(norm_file$V2, na.rm = T)

#Long format is generally better for operations like this. It's not a matrix yet, but you can ignore that
abundance_matrix <- CJ(original_assemblies, unlist(lapply(cov_depth, function(x){
  
  strsplit(strsplit(x, split = "MetaPop/03.Breadth_and_Depth/")[[1]][2], split = "_breadth_and_depth.tsv")[[1]][1]
  
})))

colnames(abundance_matrix) = c("V1", "V2")


#Initialize abundance counts at zero.
abundance_matrix$abundance = 0


#This both creates and normalizes the abundance table, with the caveats that only things with >= min. coverage or >= min bp covered are considered with depth >= 1
for(i in cov_depth){
  
  match_name <- strsplit(strsplit(i, split = "MetaPop/03.Breadth_and_Depth/")[[1]][2], split = "_breadth_and_depth.tsv")[[1]][1]
  
  #regex match here
  
  tmp <- fread(i, sep = "\t", header = F)
  
  tmp$V4[!(tmp$V3 >= coverage_cutoff | (tmp$V2*(tmp$V3/100))>=min_contig_length)] <- 0
  
  
  #This looks odd, but gets the rows which match the sample, then matches the contigs from the depths and adds in the values to the correct rows.
  abundance_matrix[V2==match_name,][match(tmp$V1, V1)]$abundance <- tmp$V4
  
}

#remove 

#Transform the abundance matrix into an actual matrix format. Rows are contigs, columns are samples.
raw_abundance_matrix <- dcast(abundance_matrix, V1~V2, value.var = "abundance")


#Goes ahead and outputs the table. This is what a person looking to send this table would want to send.
fwrite(raw_abundance_matrix, "MetaPop/11.Macrodiversity/raw_abundances_table.tsv", sep = "\t")

rm(raw_abundance_matrix)

#normalize the abundance matrix
abundance_matrix[, abundance := (abundance / norm_file$factor[match(V2, norm_file$V1)] ) ]

abundance_matrix <- dcast(abundance_matrix, V1~V2, value.var = "abundance")
rn = abundance_matrix$V1

fwrite(abundance_matrix, "MetaPop/11.Macrodiversity/normalized_abundances_table.tsv", sep = "\t")

#Technically the first column was row names. Removes it.
abundance_matrix[,V1:=NULL]

#Coverts to the R representation of a matrix instead of a data frame.
abundance_matrix <- as.matrix(abundance_matrix)

#Names the rows with their contig name.
rownames(abundance_matrix) = rn


#Determine distibution of values in matrix
data_distribution_matrix <- abundance_matrix
data_distribution_matrix <- ifelse(data_distribution_matrix==0, NA, data_distribution_matrix)
top_75_quantile <- quantile(data_distribution_matrix, probs = c(.75), na.rm = TRUE)

#Create heatmap pdf of normalized abundances
pheatmap_matrix <- abundance_matrix 
pheatmap_matrix[pheatmap_matrix > top_75_quantile[[1]]] <- top_75_quantile[[1]]

#Calculate alpha-diversity metrics
Richness<-specnumber(t(abundance_matrix)) #calculates richness
Shannons_H<- diversity(t(abundance_matrix), index = "shannon") #calculates shannon index
Simpson<- diversity(t(abundance_matrix), index = "simpson") #calculates simpson index
InvSimpson<- diversity(t(abundance_matrix), index = "invsimpson") #calculates inverse simpson index
Peilous_J <- Shannons_H/log(Richness) #calculates peilou's J
mode(abundance_matrix) <- "integer"
Fisher <- fisher.alpha(t(abundance_matrix))
Estimation_data <- estimateR(t(abundance_matrix))
Estimation_data <- t(as.data.frame(Estimation_data))
colnames(Estimation_data) <- c("Observed","Chao1","se.Chao1","ACE","se.ACE")
alpha_diversity <- cbind(Estimation_data, Shannons_H, Simpson, InvSimpson, Fisher, Peilous_J)
write.table(alpha_diversity, file = "MetaPop/11.Macrodiversity/Alpha_diveristy_stats.tsv", sep = "\t", row.names = TRUE, col.names=NA)

#Make plots of all alpha-diversity metrics with line showing the mean and median
#Make the pdfs output singletons and the 4X page for ezch

alpha_diversity<-as.data.frame(alpha_diversity)
alpha_diversity_number_samples <- nrow(alpha_diversity)
alpha_diversity_names <- rownames(alpha_diversity)
alpha_diversity_data <- as.data.frame(cbind(alpha_diversity_names, alpha_diversity))

Richness_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Observed), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Observed, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Observed, na.rm=TRUE)),color="red")+
  #change x = 4 to max(num_samples)*.25
  annotate("text", x=alpha_diversity_number_samples/4, y=median(alpha_diversity_data$Observed, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4, y=mean(alpha_diversity_data$Observed, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="Species\nRichness")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())

Chao1_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Chao1), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Chao1, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Chao1, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4, y=median(alpha_diversity_data$Chao1, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4, y=mean(alpha_diversity_data$Chao1, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="Chao1")+
  theme_bw()+
  theme(axis.title.x=element_blank(), axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())


ACE_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$ACE), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$ACE, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$ACE, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$ACE, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$ACE, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="ACE")+
  theme_bw()+
  theme(axis.title.x=element_blank(), axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())


Shannons_H_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Shannons_H), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Shannons_H, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Shannons_H, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$Shannons_H, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$Shannons_H, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="Shannon's H")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())


Simpson_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Simpson), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Simpson, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Simpson, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$Simpson, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$Simpson, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  ylab("Simpson")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())


InvSimpson_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$InvSimpson), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$InvSimpson, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$InvSimpson, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$InvSimpson, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$InvSimpson, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="Inverse Simpson")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())

Fisher_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Fisher), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Fisher, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Fisher, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$Fisher, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$Fisher, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  scale_y_continuous(name ="Fisher")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())


Peilous_J_plot <- ggplot(data=alpha_diversity_data)+
  geom_point(aes(x=alpha_diversity_data$alpha_diversity_names, y=alpha_diversity_data$Peilous_J), fill="grey", color = "black",shape=21, size = 2)+
  geom_hline(aes(yintercept=median(alpha_diversity_data$Peilous_J, na.rm=TRUE)),linetype="dotted",color="red")+
  geom_hline(aes(yintercept=mean(alpha_diversity_data$Peilous_J, na.rm=TRUE)),color="red")+
  annotate("text", x=alpha_diversity_number_samples/4,y=median(alpha_diversity_data$Peilous_J, na.rm=TRUE) ,label = "Median", color = "red", size = 4, vjust = 1)+
  annotate("text", x=alpha_diversity_number_samples*3/4,y=mean(alpha_diversity_data$Peilous_J, na.rm=TRUE) ,label = "Mean", color = "red", size = 4, vjust = 0)+
  xlab("Samples")+
  ylab("Peilous J")+
  theme_bw()+
  theme(axis.title.x=element_blank(),axis.text.x = element_text(angle = 90, size = 6),axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())

try({

#Make pdf of alpha diversity scatterplots
pdf("MetaPop/12.Visualizations/alpha_diversity_scatterplots.pdf", width = 16, height = 16/3)

print(Richness_plot)
print(Shannons_H_plot)
print(Simpson_plot)
print(Peilous_J_plot)

print(Chao1_plot)
print(ACE_plot)
print(InvSimpson_plot)
print(Fisher_plot)

dev.off()

})


#Calculate beta-diversity metrics
clr_transformation <- clr(t(abundance_matrix))
clr_euc <-vegdist(clr_transformation, method="euclidean") 
clr_euc <- as.matrix(clr_euc)
write.table(clr_euc, file = "MetaPop/11.Macrodiversity/Beta_diveristy_clr_transformed_euclidean_distances.tsv", sep = "\t", row.names = TRUE, col.names=NA)
bray <-vegdist(t(abundance_matrix), method="bray") 
bray <- as.matrix(bray)
write.table(bray, file = "MetaPop/11.Macrodiversity/Beta_diveristy_bray_distances.tsv", sep = "\t", row.names = TRUE, col.names=NA)
jaccard <-vegdist(t(abundance_matrix), method="jaccard") 
jaccard <- as.matrix(jaccard)
write.table(jaccard, file = "MetaPop/11.Macrodiversity/Beta_diveristy_jaccard_distances.tsv", sep = "\t", row.names = TRUE, col.names=NA)

if(ncol(clr_euc) < 3){
  print("There are not enough samples to produce a meaningful PCA, PCoA, or NMDS analysis. At least 3 are required.")
  print("There will be data outputs for these analyses in MetaPop/11.Macrodiversity/, but no visualizations.")
  print("As these outputs are distances, there is not much meaning in the data output.")
}else{
  
  #Make PCA plots of all beta-diversity metrics
  clr_euc.pca<-prcomp(clr_euc, scale = TRUE)
  clr_euc.eig2 <- eigenvals(clr_euc.pca)
  clr_euc.percentage_variance_explained <- clr_euc.eig2 / sum(clr_euc.eig2)
  clr_euc.PC1_percent <- as.numeric(format(round((clr_euc.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  clr_euc.PC2_percent <- as.numeric(format(round((clr_euc.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  clr_euc.PC1_percent= sprintf("%.2f%%", clr_euc.PC1_percent)
  clr_euc.PC2_percent= sprintf("%.2f%%", clr_euc.PC2_percent)
  clr_euc.PC1_percent= paste ("PC1 (",clr_euc.PC1_percent,")")
  clr_euc.PC2_percent= paste ("PC2 (",clr_euc.PC2_percent,")")
  clr_euc.components <- as.data.frame(clr_euc.pca$x)
  clr_euc.components.richness <- as.data.frame(cbind(clr_euc.components, alpha_diversity)) ##add alpha diversity values
  
  CLR_EUC_PCA_PLOT <- ggplot(data=clr_euc.components.richness)+
    geom_label_repel(data=clr_euc.components.richness,aes(x=clr_euc.components.richness$PC1, y=clr_euc.components.richness$PC2, label=rownames(clr_euc.components.richness)))+
    geom_point(aes(x=clr_euc.components.richness$PC1, y=clr_euc.components.richness$PC2, fill=clr_euc.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Centered-log Ratio Transformed Euclidean Distances")+
    labs(fill = "Species Richness")+xlab(clr_euc.PC1_percent)+
    ylab(clr_euc.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(clr_euc.components.richness$PC1, clr_euc.components.richness$PC2), na.rm=T), max(c(clr_euc.components.richness$PC1, clr_euc.components.richness$PC2), na.rm = T))) +
    ylim(c(min(c(clr_euc.components.richness$PC1, clr_euc.components.richness$PC2), na.rm=T), max(c(clr_euc.components.richness$PC1, clr_euc.components.richness$PC2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  bray.pca<-prcomp(bray, scale = TRUE)
  bray.eig2 <- eigenvals(bray.pca)
  bray.percentage_variance_explained <- bray.eig2 / sum(bray.eig2)
  bray.PC1_percent <- as.numeric(format(round((bray.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  bray.PC2_percent <- as.numeric(format(round((bray.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  bray.PC1_percent= sprintf("%.2f%%", bray.PC1_percent)
  bray.PC2_percent= sprintf("%.2f%%", bray.PC2_percent)
  bray.PC1_percent= paste ("PC1 (",bray.PC1_percent,")")
  bray.PC2_percent= paste ("PC2 (",bray.PC2_percent,")")
  bray.components <- as.data.frame(bray.pca$x)
  bray.components.richness <- as.data.frame(cbind(bray.components, alpha_diversity)) ##add alpha diversity values
  
  BRAY_PCA_PLOT <- ggplot(data=bray.components.richness)+
    geom_label_repel(data=bray.components.richness,aes(x=bray.components.richness$PC1, y=bray.components.richness$PC2, label=rownames(bray.components.richness)))+
    geom_point(aes(x=bray.components.richness$PC1, y=bray.components.richness$PC2, fill=bray.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Bray-Curtis (Dissimilarity) Distances")+
    labs(fill = "Species Richness")+xlab(bray.PC1_percent)+
    ylab(bray.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(bray.components.richness$PC1, bray.components.richness$PC2), na.rm=T), max(c(bray.components.richness$PC1, bray.components.richness$PC2), na.rm = T))) +
    ylim(c(min(c(bray.components.richness$PC1, bray.components.richness$PC2), na.rm=T), max(c(bray.components.richness$PC1, bray.components.richness$PC2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  jaccard.pca<-prcomp(jaccard, scale = TRUE)
  jaccard.eig2 <- eigenvals(jaccard.pca)
  jaccard.percentage_variance_explained <- jaccard.eig2 / sum(jaccard.eig2)
  jaccard.PC1_percent <- as.numeric(format(round((jaccard.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  jaccard.PC2_percent <- as.numeric(format(round((jaccard.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  jaccard.PC1_percent= sprintf("%.2f%%", jaccard.PC1_percent)
  jaccard.PC2_percent= sprintf("%.2f%%", jaccard.PC2_percent)
  jaccard.PC1_percent= paste ("PC1 (",jaccard.PC1_percent,")")
  jaccard.PC2_percent= paste ("PC2 (",jaccard.PC2_percent,")")
  jaccard.components <- as.data.frame(jaccard.pca$x)
  jaccard.components.richness <- as.data.frame(cbind(jaccard.components, alpha_diversity)) ##add alpha diversity values
  
  JACCARD_PCA_PLOT <- ggplot(data=jaccard.components.richness)+
    geom_label_repel(data=jaccard.components.richness,aes(x=jaccard.components.richness$PC1, y=jaccard.components.richness$PC2, label=rownames(jaccard.components.richness)))+
    geom_point(aes(x=jaccard.components.richness$PC1, y=jaccard.components.richness$PC2, fill=jaccard.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Jaccard (Similarity) Distances")+
    labs(fill = "Species Richness")+
    xlab(jaccard.PC1_percent)+ylab(jaccard.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(jaccard.components.richness$PC1, jaccard.components.richness$PC2), na.rm=T), max(c(jaccard.components.richness$PC1, jaccard.components.richness$PC2), na.rm = T))) +
    ylim(c(min(c(jaccard.components.richness$PC1, jaccard.components.richness$PC2), na.rm=T), max(c(jaccard.components.richness$PC1, jaccard.components.richness$PC2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  
  try({
  
  #Make pdf of PCA plots
  pdf("MetaPop/12.Visualizations/PCA_CLR.EUC_BRAY_JACCARD_plot.pdf", width = 9, height = 9)
  print(CLR_EUC_PCA_PLOT)
  print(BRAY_PCA_PLOT)
  print(JACCARD_PCA_PLOT)
  dev.off()
  
  })
  
  #Make PCOA plots of all beta-diversity metrics
  clr_euc.pcoa<-capscale(clr_euc~-1)
  clr_euc.eig2 <- eigenvals(clr_euc.pcoa)
  clr_euc.percentage_variance_explained <- clr_euc.eig2 / sum(clr_euc.eig2)
  clr_euc.PC1_percent <- as.numeric(format(round((clr_euc.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  clr_euc.PC2_percent <- as.numeric(format(round((clr_euc.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  clr_euc.PC1_percent= sprintf("%.2f%%", clr_euc.PC1_percent)
  clr_euc.PC2_percent= sprintf("%.2f%%", clr_euc.PC2_percent)
  clr_euc.PC1_percent= paste ("PCo1 (",clr_euc.PC1_percent,")")
  clr_euc.PC2_percent= paste ("PCo2 (",clr_euc.PC2_percent,")")
  clr_euc.components <- as.data.frame(scores(clr_euc.pcoa, display=c("sites")))
  clr_euc.components.richness <- as.data.frame(cbind(clr_euc.components, alpha_diversity)) ##add alpha diversity values
  
  CLR_EUC_PCOA_PLOT <- ggplot(data=clr_euc.components.richness)+
    geom_label_repel(data=clr_euc.components.richness,aes(x=clr_euc.components.richness$MDS1, y=clr_euc.components.richness$MDS2, label=rownames(clr_euc.components.richness)))+
    geom_point(aes(x=clr_euc.components.richness$MDS1, y=clr_euc.components.richness$MDS2, fill=clr_euc.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Centered-log Ratio Transformed Euclidean Distances")+
    labs(fill = "Species Richness")+
    xlab(clr_euc.PC1_percent)+
    ylab(clr_euc.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(clr_euc.components.richness$MDS1, clr_euc.components.richness$MDS2), na.rm=T), max(c(clr_euc.components.richness$MDS1, clr_euc.components.richness$MDS2), na.rm = T))) +
    ylim(c(min(c(clr_euc.components.richness$MDS1, clr_euc.components.richness$MDS2), na.rm=T), max(c(clr_euc.components.richness$MDS1, clr_euc.components.richness$MDS2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  
  bray.pcoa<-capscale(bray~-1)
  bray.eig2 <- eigenvals(bray.pcoa)
  bray.percentage_variance_explained <- bray.eig2 / sum(bray.eig2)
  bray.PC1_percent <- as.numeric(format(round((bray.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  bray.PC2_percent <- as.numeric(format(round((bray.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  bray.PC1_percent= sprintf("%.2f%%", bray.PC1_percent)
  bray.PC2_percent= sprintf("%.2f%%", bray.PC2_percent)
  bray.PC1_percent= paste ("PCo1 (",bray.PC1_percent,")")
  bray.PC2_percent= paste ("PCo2 (",bray.PC2_percent,")")
  bray.components <- as.data.frame(scores(bray.pcoa, display=c("sites")))
  bray.components.richness <- as.data.frame(cbind(bray.components, alpha_diversity)) ##add alpha diversity values
  
  BRAY_PCOA_PLOT <- ggplot(data=bray.components.richness)+
    geom_label_repel(data=bray.components.richness,aes(x=bray.components.richness$MDS1, y=bray.components.richness$MDS2, label=rownames(bray.components.richness)))+
    geom_point(aes(x=bray.components.richness$MDS1, y=bray.components.richness$MDS2, fill=bray.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Bray-Curtis (Dissimilarity) Distances")+
    labs(fill = "Species Richness")+
    xlab(bray.PC1_percent)+
    ylab(bray.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(bray.components.richness$MDS1, bray.components.richness$MDS2), na.rm=T), max(c(bray.components.richness$MDS1, bray.components.richness$MDS2), na.rm = T))) +
    ylim(c(min(c(bray.components.richness$MDS1, bray.components.richness$MDS2), na.rm=T), max(c(bray.components.richness$MDS1, bray.components.richness$MDS2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  
  jaccard.pcoa<-capscale(jaccard~-1)
  jaccard.eig2 <- eigenvals(jaccard.pcoa)
  jaccard.percentage_variance_explained <- jaccard.eig2 / sum(jaccard.eig2)
  jaccard.PC1_percent <- as.numeric(format(round((jaccard.percentage_variance_explained[[1]]*100), 2), nsmall = 2))
  jaccard.PC2_percent <- as.numeric(format(round((jaccard.percentage_variance_explained[[2]]*100), 2), nsmall = 2))
  jaccard.PC1_percent= sprintf("%.2f%%", jaccard.PC1_percent)
  jaccard.PC2_percent= sprintf("%.2f%%", jaccard.PC2_percent)
  jaccard.PC1_percent= paste ("PCo1 (",jaccard.PC1_percent,")")
  jaccard.PC2_percent= paste ("PCo2 (",jaccard.PC2_percent,")")
  jaccard.components <- as.data.frame(scores(jaccard.pcoa, display=c("sites")))
  jaccard.components.richness <- as.data.frame(cbind(jaccard.components, alpha_diversity)) ##add alpha diversity values
  
  JACCARD_PCOA_PLOT <- ggplot(data=jaccard.components.richness)+
    geom_label_repel(data=jaccard.components.richness,aes(x=jaccard.components.richness$MDS1, y=jaccard.components.richness$MDS2, label=rownames(jaccard.components.richness)))+
    geom_point(aes(x=jaccard.components.richness$MDS1, y=jaccard.components.richness$MDS2, fill=jaccard.components.richness$Observed), color = "black",shape=21, size = 4)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Jaccard (Similarity) Distances")+
    labs(fill = "Species Richness")+
    xlab(jaccard.PC1_percent)+
    ylab(jaccard.PC2_percent)+
    theme_bw()+
    xlim(c(min(c(jaccard.components.richness$MDS1, jaccard.components.richness$MDS2), na.rm=T), max(c(jaccard.components.richness$MDS1, jaccard.components.richness$MDS2), na.rm = T))) +
    ylim(c(min(c(jaccard.components.richness$MDS1, jaccard.components.richness$MDS2), na.rm=T), max(c(jaccard.components.richness$MDS1, jaccard.components.richness$MDS2), na.rm = T))) +
    coord_fixed() +
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())
  
  try({
  
  #Make pdf of PCoA plots
  pdf("MetaPop/12.Visualizations/PCoA_CLR.EUC_BRAY_JACCARD_plot.pdf", width = 9, height = 9)
  print(CLR_EUC_PCOA_PLOT)
  print(BRAY_PCOA_PLOT)
  print(JACCARD_PCOA_PLOT)
  dev.off()
  
  })
  
  #Make NMDS plots of all beta-diversity metrics
  clr_euc.nmds<-metaMDS(clr_euc, k=2)
  clr_euc.stress <- clr_euc.nmds$stress
  clr_euc.stress= sprintf("%#.3f", clr_euc.stress)
  clr_euc.stress = paste ("stress = ",clr_euc.stress,"")
  clr_euc.points <- clr_euc.nmds$points 
  clr_euc.points.richness <- as.data.frame(cbind(clr_euc.points, alpha_diversity)) ##add alpha diversity values
  
  CLR_EUC_NMDS_PLOT <- ggplot(data=clr_euc.points.richness)+
    geom_label_repel(data=clr_euc.components.richness,aes(x=clr_euc.components.richness$MDS1, y=clr_euc.components.richness$MDS2, label=rownames(clr_euc.components.richness)))+
    geom_point(aes(x=clr_euc.points.richness$MDS1, y=clr_euc.points.richness$MDS2, fill=clr_euc.components.richness$Observed), color = "black",shape=21, size = 4)+
    annotate(geom = 'text', label = clr_euc.stress, x = -Inf, y = Inf, hjust = 0, vjust = 1)+scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Centered-log Ratio Transformed Euclidean Distances")+
    labs(fill = "Species Richness")+xlab("NMDS1")+
    ylab("NMDS2")+
    theme_bw()+
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())+
    xlim(min(c(clr_euc.points.richness$MDS1, clr_euc.points.richness$MDS2), na.rm = T),  max(c(clr_euc.points.richness$MDS1, clr_euc.points.richness$MDS2), na.rm = T)) +
    ylim(min(c(clr_euc.points.richness$MDS1, clr_euc.points.richness$MDS2), na.rm = T),  max(c(clr_euc.points.richness$MDS1, clr_euc.points.richness$MDS2), na.rm = T)) +
    coord_fixed()
  
  
  
  bray.nmds<-metaMDS(bray, k=2)
  bray.stress <- bray.nmds$stress
  bray.stress= sprintf("%#.3f", bray.stress)
  bray.stress = paste ("stress = ",bray.stress,"")
  bray.points <- bray.nmds$points 
  bray.points.richness <- as.data.frame(cbind(bray.points, alpha_diversity)) ##add alpha diversity values
  
  BRAY_NMDS_PLOT <- ggplot(data=bray.points.richness)+
    geom_label_repel(data=bray.components.richness,aes(x=bray.components.richness$MDS1, y=bray.components.richness$MDS2, label=rownames(bray.components.richness)))+
    geom_point(aes(x=bray.points.richness$MDS1, y=bray.points.richness$MDS2, fill=bray.components.richness$Observed), color = "black",shape=21, size = 4)+
    annotate(geom = 'text', label = bray.stress, x = -Inf, y = Inf, hjust = 0, vjust = 1)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Bray-Curtis (Dissimilarity) Distances")+
    labs(fill = "Species Richness")+
    xlab("NMDS1")+
    ylab("NMDS2")+
    theme_bw()+
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())+
    xlim(min(c(bray.points.richness$MDS1, bray.points.richness$MDS2), na.rm = T),  max(c(bray.points.richness$MDS1, bray.points.richness$MDS2), na.rm = T)) +
    ylim(min(c(bray.points.richness$MDS1, bray.points.richness$MDS2), na.rm = T),  max(c(bray.points.richness$MDS1, bray.points.richness$MDS2), na.rm = T)) +
    coord_fixed()
  
  
  jaccard.nmds<-metaMDS(jaccard, k=2)
  jaccard.stress <- jaccard.nmds$stress
  jaccard.stress= sprintf("%#.3f", jaccard.stress)
  jaccard.stress = paste ("stress = ",jaccard.stress,"")
  jaccard.points <- jaccard.nmds$points 
  jaccard.points.richness <- as.data.frame(cbind(jaccard.points, alpha_diversity)) ##add alpha diversity values
  
  JACCARD_NMDS_PLOT <- ggplot(data=jaccard.points.richness)+
    geom_label_repel(data=jaccard.components.richness,aes(x=jaccard.components.richness$MDS1, y=jaccard.components.richness$MDS2, label=rownames(jaccard.components.richness)))+
    geom_point(aes(x=jaccard.points.richness$MDS1, y=jaccard.points.richness$MDS2, fill=jaccard.components.richness$Observed), color = "black",shape=21, size = 4)+
    annotate(geom = 'text', label = jaccard.stress, x = -Inf, y = Inf, hjust = 0, vjust = 1)+
    scale_fill_gradientn(colours = terrain.colors(10))+
    ggtitle("Jaccard (Similarity) Distances")+
    labs(fill = "Species Richness")+
    xlab("NMDS1")+
    ylab("NMDS2")+
    theme_bw()+
    theme(axis.line.x = element_line(color="black", size = 0.5),axis.line.y = element_line(color="black", size = 0.5),panel.border = element_blank(),panel.grid.major = element_blank(),panel.grid.minor = element_blank())+
    xlim(min(c(jaccard.points.richness$MDS1, jaccard.points.richness$MDS2), na.rm = T),  max(c(jaccard.points.richness$MDS1, jaccard.points.richness$MDS2), na.rm = T)) +
    ylim(min(c(jaccard.points.richness$MDS1, jaccard.points.richness$MDS2), na.rm = T),  max(c(jaccard.points.richness$MDS1, jaccard.points.richness$MDS2), na.rm = T)) +
    coord_fixed()
  
  try({
  #Make pdf of NMDS plots
  pdf("MetaPop/12.Visualizations/NMDS_CLR.EUC_BRAY_JACCARD_plot.pdf", width = 9, height = 9)
  par(pty="s")
  print(CLR_EUC_NMDS_PLOT)
  print(BRAY_NMDS_PLOT)
  print(JACCARD_NMDS_PLOT)
  dev.off()
  })
  
}

if(length(cov_depth) > 1){
  print("Heatmaps are very memory intensive. MetaPop will attempt to print normalized abundance heatmaps, but these may fail.")
  
  try({
    
    abundance_matrix_nozero <- abundance_matrix[ rowSums(abundance_matrix)!=0, ]
    
    pdf("MetaPop/12.Visualizations/normalized_abundances_heatmap.pdf")
    
    pheatmap(abundance_matrix_nozero,
             scale="none",
             cluster_cols = T,
             cluster_rows = T,
             show_rownames = F, 
             show_colnames = T,
             fontsize_col = 5+1/log10(ncol(abundance_matrix)), 
             breaks=c(-0.00001,0,seq(0.0000001,max(abundance_matrix),length.out=50)), 
             border_color=NA, 
             col=c("white",colorRampPalette(brewer.pal(11,"Spectral"))(59)))
    
    
    dev.off()
    
  })
  
  
  try({
    
    pheatmap_matrix_nozero <- pheatmap_matrix[ rowSums(pheatmap_matrix)!=0, ]
    
    pdf("MetaPop/12.Visualizations/normalized_abundances_heatmap_75_quantile_removed.pdf")
    
    pheatmap(pheatmap_matrix_nozero,
             scale="none",
             cluster_cols = T,
             cluster_rows = T,
             show_rownames = F, 
             show_colnames = T,
             fontsize_col = 5+1/log10(ncol(pheatmap_matrix)), 
             breaks=c(-0.00001,0,seq(0.0000001,top_75_quantile[[1]],length.out=50)), 
             border_color=NA, 
             col=c("white",colorRampPalette(brewer.pal(11,"Spectral"))(59)))
    
    dev.off()
    
  })
  
}else{
  print("Cannot make a heatmap with only one sample.")
}

options <- commandArgs(trailingOnly = T)

input = options[1]
library_location <- options[2]

if(library_location == ""){
  library_location <- .libPaths()
}

suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))

linkage_test <- function(all_ref, second_is_ref, first_is_ref, all_snp){
  
  contingency_table <- matrix(c(all_ref, second_is_ref, first_is_ref, all_snp), nrow = 2, ncol = 2)
  
  if(any(contingency_table < 0)){
    return(list(NA, NA))
  }
  
  
  p <- fisher.test(contingency_table)$p
  top <- (all_ref*all_snp)-(second_is_ref*first_is_ref)
  botA <- sqrt(all_ref+first_is_ref)
  botB <- sqrt(all_ref+second_is_ref)
  botC <- sqrt(all_snp+first_is_ref)
  botD <- sqrt(all_snp+second_is_ref)
  botDiv <- botA*botB*botC*botD
  
  phi <- top/botDiv
  
  return(list(p, phi))
  
}

linked_data = fread(input, sep = "\t")


linkage_results <- mapply(linkage_test, linked_data$ref_count, linked_data$ref_second, linked_data$ref_first, linked_data$snp_count)

linked_data$fisher_p <- unlist(linkage_results[c(T,F)])
linked_data$phi_coef <- unlist(linkage_results[c(F,T)])

linked_data <- linked_data[!is.na(linked_data$fisher_p),]

fwrite(linked_data, input, sep = "\t", col.names = T)

options <- commandArgs(trailingOnly = T)

#universal
directory_name <- options[1]
threads <- as.numeric(options[2])
library_location <- options[3]

if(library_location == ""){
   library_location <- .libPaths()
}

ref_fasta <- options[4]
ref_genes <- options[5]

#Component specific
min_cov <- as.numeric(options[6])
min_dep <- as.numeric(options[7])

sub_samp <- as.numeric(options[8])

setwd(directory_name)


suppressMessages(suppressWarnings(library(doParallel, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))
suppressMessages(suppressWarnings(library(stringr, lib.loc = library_location)))

#These get used later, so it's good to declare them now.
{
   
   #use the geom. mean of the depths across subsampled loci to determine harmonic number. Ceiling to be conservative.
   #I'll need to translate this set into a function.
   
   tajima_d_parameterization <- function(sample_size){
      harmonic <- sum(1/(c(1:(sample_size-1))))
      harmonic2 <- sum(1/(c((1:(sample_size-1))^2)))
      b1<-(sample_size+1)/(3*(sample_size-1))
      b2 <- (2*(sample_size^2+sample_size+3))/(9*sample_size*(sample_size-1))
      c1 <- b1-(1/harmonic)
      c2 <- b2-((sample_size+2)/(harmonic*sample_size)) + harmonic2/(harmonic^2)
      e1 <- c1/harmonic
      e2<-c2/(harmonic^2+harmonic2)
      
      return(list(harmonic, harmonic2, b1, b2, c1, c2, e1, e2))
   }
   
   harmony <- unlist(lapply(1:(sub_samp + 5), tajima_d_parameterization))
   
   harmonic <- harmony[c(T,F,F,F,F,F,F,F)]
   harmonic2 <- harmony[c(F,T,F,F,F,F,F,F)]
   b1 <- harmony[c(F,F,T,F,F,F,F,F)]
   b2 <- harmony[c(F,F,F,T,F,F,F,F)]
   c1 <- harmony[c(F,F,F,F,T,F,F,F)]
   c2 <- harmony[c(F,F,F,F,F,T,F,F)]
   e1 <- harmony[c(F,F,F,F,F,F,T,F)]
   e2 <- harmony[c(F,F,F,F,F,F,F,T)]
   
   construct <- c("AAA", "AAT", "AAC", "AAG",
                  "ATA", "ATT", "ATC", "ATG",
                  "ACA", "ACT", "ACC", "ACG",
                  "AGA", "AGT", "AGC", "AGG",
                  
                  "TAA", "TAT", "TAC", "TAG",
                  "TTA", "TTT", "TTC", "TTG",
                  "TCA", "TCT", "TCC", "TCG",
                  "TGA", "TGT", "TGC", "TGG",
                  
                  "CAA", "CAT", "CAC", "CAG",
                  "CTA", "CTT", "CTC", "CTG",
                  "CCA", "CCT", "CCC", "CCG",
                  "CGA", "CGT", "CGC", "CGG",
                  
                  "GAA", "GAT", "GAC", "GAG",
                  "GTA", "GTT", "GTC", "GTG",
                  "GCA", "GCT", "GCC", "GCG",
                  "GGA", "GGT", "GGC", "GGG")
   
   reverseComplement <- unlist(lapply(construct,function(x){
      
      reversed <- intToUtf8(rev(utf8ToInt(x)))
      complimented <- chartr("ATCG", "TAGC", reversed)
      
   }))
   
   proteinConstruct <- c("K", "N", "N", "K",
                         "I", "I", "I", "M",
                         "T", "T", "T", "T",
                         "R", "S", "S", "R",
                         
                         "STOP", "Y", "Y", "STOP",
                         "L", "F", "F", "L",
                         "S", "S", "S", "S",
                         "STOP", "C", "C", "W",
                         
                         "Q", "H", "H", "Q",
                         "L", "L", "L", "L",
                         "P", "P", "P", "P",
                         "R", "R", "R", "R",
                         
                         "E", "D", "D", "E",
                         "V", "V", "V", "V",
                         "A", "A", "A", "A",
                         "G", "G", "G", "G")
   
   expNConstruct<- c(8/3, 8/3, 8/3, 8/3,
                     7/3, 7/3, 7/3, 3,
                     2,2,2,2,
                     7/3,8/3,8/3,7/3,
                     
                     7/3, 8/3, 8/3,8/3,
                     7/3,8/3,8/3,7/3,
                     2,2,2,2,
                     8/3,8/3,8/3,3,
                     
                     8/3,8/3,8/3,8/3,
                     5/3,1,1,5/3,
                     2,2,2,2,
                     5/3,2,2,5/3,
                     
                     8/3,8/3,8/3,8/3,
                     2,2,2,2,
                     2,2,2,2,
                     2,2,2,2)
   
   expSConstruct <- 3-expNConstruct
}

genes <- fread("MetaPop/08.Codon_Bias/codon_bias_sequences.tsv", sep = "\t", header = F, select = c(3,4))
colnames(genes) = c("V1", "V2")

#Codon bias
# if(dir.exists("MetaPop/08.Codon_Bias") & !file.exists("MetaPop/08.Codon_Bias/gene_IQR_and_mean.tsv")){
#CB code used to go here.
# }

#subsample and microdiversity
# Occasionally the subsample will take 1 more than the sub_samp value indicates it should. 
# This happens because the particular counts and scaling factor sample_prop round up more than once


   # The normal data
   microdiv_data <- fread("MetaPop/07.Cleaned_SNPs/genic_snps.tsv", sep = "\t", header = T)
   
   setkeyv(microdiv_data, c("source", "contig"))
   
   non_genic_data <- fread("MetaPop/07.Cleaned_SNPs/non_genic_snps.tsv", sep = "\t", header = T)
   
   microdiv_data[,link := NULL]
   microdiv_data[, depth := a_ct+t_ct+c_ct+g_ct]
   # Can't calculate pi/etc on only one obs
   microdiv_data <- microdiv_data[microdiv_data$depth > 1]
   
   #This is collecting the number of SNPs in first, second, and 3rd position in codon over the genic SNPs, stratified by sample and contig. 
   codon_pos_count <- microdiv_data[,list(first_pos = sum(pos_in_codon==1), second_pos = sum(pos_in_codon==2), third_pos = sum(pos_in_codon==3)), by = key(microdiv_data)]
   
   microdiv_data$sample_prop <- sub_samp/microdiv_data$depth
   microdiv_data$sub_samp_a <- ifelse(microdiv_data$sample_prop < 1, round(microdiv_data$a_ct * microdiv_data$sample_prop), microdiv_data$a_ct)
   microdiv_data$sub_samp_t <- ifelse(microdiv_data$sample_prop < 1, round(microdiv_data$t_ct * microdiv_data$sample_prop), microdiv_data$t_ct)
   microdiv_data$sub_samp_c <- ifelse(microdiv_data$sample_prop < 1, round(microdiv_data$c_ct * microdiv_data$sample_prop), microdiv_data$c_ct)
   microdiv_data$sub_samp_g <- ifelse(microdiv_data$sample_prop < 1, round(microdiv_data$g_ct * microdiv_data$sample_prop), microdiv_data$g_ct)
   #Get the new depth per pos for pi calc
   microdiv_data[, sub_samp_depth := sub_samp_a+sub_samp_t+sub_samp_c+sub_samp_g]
   
   microdiv_data[,pi := 2*(((sub_samp_a * (sub_samp_t+sub_samp_c+sub_samp_g))+(sub_samp_t*(sub_samp_c+sub_samp_g))+(sub_samp_c*sub_samp_g))/((sub_samp_depth*sub_samp_depth)-sub_samp_depth))]
   
   non_genic_data[, depth := a_ct+t_ct+c_ct+g_ct]
   # Can't calculate pi/etc on only one obs
   non_genic_data <- non_genic_data[non_genic_data$depth > 1]
   non_genic_data$sample_prop <- sub_samp/non_genic_data$depth
   non_genic_data$sub_samp_a <- ifelse(non_genic_data$sample_prop < 1, round(non_genic_data$a_ct * non_genic_data$sample_prop), non_genic_data$a_ct)
   non_genic_data$sub_samp_t <- ifelse(non_genic_data$sample_prop < 1, round(non_genic_data$t_ct * non_genic_data$sample_prop), non_genic_data$t_ct)
   non_genic_data$sub_samp_c <- ifelse(non_genic_data$sample_prop < 1, round(non_genic_data$c_ct * non_genic_data$sample_prop), non_genic_data$c_ct)
   non_genic_data$sub_samp_g <- ifelse(non_genic_data$sample_prop < 1, round(non_genic_data$g_ct * non_genic_data$sample_prop), non_genic_data$g_ct)
   
   #Get the new depth per pos for pi calc
   non_genic_data[, sub_samp_depth := sub_samp_a+sub_samp_t+sub_samp_c+sub_samp_g]
   
   non_genic_data[,pi := 2*(((sub_samp_a * (sub_samp_t+sub_samp_c+sub_samp_g))+(sub_samp_t*(sub_samp_c+sub_samp_g))+(sub_samp_c*sub_samp_g))/((sub_samp_depth*sub_samp_depth)-sub_samp_depth))]
   
   get_names_and_lengths_from_fasta <- function(file){
      
      original_assemblies <- readLines(file)
      
      header_lines = substr(original_assemblies, 1, 1) == ">"
      
      seq_ids = original_assemblies[header_lines]
      
      char_counts = nchar(original_assemblies)
      #char_counts[header_lines] = 0
      
      rm(original_assemblies)
      
      lengths = rep(0, sum(header_lines))
      
      current_length = 0
      headers_count = 1
      
      for(i in 2:length(header_lines)){
         if(header_lines[i]){
            lengths[headers_count] = current_length
            headers_count = headers_count + 1
            current_length = 0
         }else{
            current_length = current_length + char_counts[i]
         }
         
      }
      
      #Final iter
      lengths[headers_count] = current_length
      
      
      seq_ids =  substr(seq_ids, 2, nchar(seq_ids ))
      
      seq_ids  <- unlist(lapply(seq_ids , function(x){
         
         res  = strsplit(x, split = ' ')[[1]]
         if(length(res) > 1){
            res = res[1]
         }
         
         return(res)
         
      }))
      
      result = data.table(seq_ids, lengths)
      
      return(result)
      
   }
   
   # For theta and pi, we need the lengths of the genomes and the genes
   assembled_contigs = get_names_and_lengths_from_fasta(ref_fasta)
   colnames(assembled_contigs) = c("contig", "length")
   
   
   gene_assembly <- fread("MetaPop/08.Codon_Bias/codon_bias_sequences.tsv", sep = "\t")
   colnames(gene_assembly) = c("seq", "OC", "gene", "contig")
   gene_assembly$length <- nchar(gene_assembly$seq)
   
   #Likely needs to be separate
   depth_file_names <- list.files(path = "MetaPop/03.Breadth_and_Depth", full.names = T)
   
   #returns a 0 length data.table if there are no passing contigs
   depth_info <- lapply(depth_file_names, function(x){
      tmp <- fread(x, sep = "\t")
      tmp$source <- substr(x, 30, nchar(x)-22)
      tmp <- tmp[V3 >= min_cov & V4 >= min_dep,]
      return(tmp)
   })
   
   names(depth_info) = substr(depth_file_names, 30, nchar(depth_file_names)-22)
   
   #removes the 0 length data.tables, i.e. samples with no passing contigs
   depth_info <- depth_info[unlist(lapply(depth_info, nrow)) > 0]
   
   #We need to keep the genes from these files for filling out the gene table later.
   all_contigs <- unique(unlist(lapply(depth_info, function(x){
      
      return(unique(x$V1))
      
   })))
   
   #Keeps only the genes belonging to contigs that passed at least one sample. The genes are shared by all samples, so there's no need to have these per sample
   gene_assembly <- gene_assembly[gene_assembly$contig %in% all_contigs,]
   
   #figure out what position in each gene the base falls.
   #genes are reverse complemented, so this should be fine
   pos_in_gene <- ((microdiv_data$codon-1)*3) + microdiv_data$pos_in_codon
   
   
   split_codons <- unname(lapply(gene_assembly$seq, function(x){
      str <- strsplit(x, split = "")[[1]]
      codons <- paste0(str[c(T,F,F)],
                       str[c(F,T,F)],
                       str[c(F,F,T)])
      return(codons)
   }))
   
   exp_N_S <- sapply(split_codons, function(x){
      
      N <- sum(expNConstruct[match(x, construct)])
      S <- sum(expSConstruct[match(x, construct)])
      
      return(list(N, S))
   })
   
   gene_assembly$expN <- as.numeric(exp_N_S[1,])
   gene_assembly$expS <- as.numeric(exp_N_S[2,])
   
   microdiv_data$original_codon <- mapply(function(codons, index){
      
      return(codons[index])
      
   }, split_codons[match(microdiv_data$contig_gene, gene_assembly$gene)], microdiv_data$codon)
   
   #Some codons are illegitimate on account of being on edges. Very few, but they need to be gone.
   microdiv_data <- microdiv_data[microdiv_data$original_codon %in% construct,]
   
   microdiv_data$original_AA <- proteinConstruct[match(microdiv_data$original_codon, construct)]
   
   #Handling SNPs - some positions have 2 or 3, and these need special handling.
   snps_by_row <- nchar(microdiv_data$snps)
   #Initial setup
   microdiv_data[,obsN := 0]
   microdiv_data[,obsS := 0]
   
   
   
   #This first bit handles the first, usually only, SNP per row and sets up the overall N/S output.
   first_snp <- substr(microdiv_data$snps, 1, 1)
   OG_cod <- microdiv_data$original_codon
   substr(OG_cod, microdiv_data$pos_in_codon, microdiv_data$pos_in_codon) <- first_snp
   OG_cod <- proteinConstruct[match(OG_cod, construct)] == microdiv_data$original_AA
   
   isA <- first_snp == "A"
   isT <- first_snp == "T"
   isC <- first_snp == "C"
   isG <- first_snp == "G"
   
   microdiv_data$obsN[(isA & !OG_cod)] <- microdiv_data$sub_samp_a[(isA & !OG_cod)]
   microdiv_data$obsN[(isT & !OG_cod)] <- microdiv_data$sub_samp_t[(isT & !OG_cod)]
   microdiv_data$obsN[(isC & !OG_cod)] <- microdiv_data$sub_samp_c[(isC & !OG_cod)]
   microdiv_data$obsN[(isG & !OG_cod)] <- microdiv_data$sub_samp_g[(isG & !OG_cod)]
   
   microdiv_data$obsS[(isA & OG_cod)] <- microdiv_data$sub_samp_a[(isA & OG_cod)]
   microdiv_data$obsS[(isT & OG_cod)] <- microdiv_data$sub_samp_t[(isT & OG_cod)]
   microdiv_data$obsS[(isC & OG_cod)] <- microdiv_data$sub_samp_c[(isC & OG_cod)]
   microdiv_data$obsS[(isG & OG_cod)] <- microdiv_data$sub_samp_g[(isG & OG_cod)]
   
   
   #Second SNP where applicable - here meaning multiple alleles on a single locus.
   second_snp <- substr(microdiv_data$snps[snps_by_row > 1], 2, 2)
   OG_cod <- microdiv_data$original_codon[snps_by_row > 1]
   
   substr(OG_cod, microdiv_data$pos_in_codon[snps_by_row > 1], microdiv_data$pos_in_codon[snps_by_row > 1]) <- second_snp
   OG_cod <- proteinConstruct[match(OG_cod, construct)] == microdiv_data$original_AA[snps_by_row > 1]
   
   isA <- second_snp == "A"
   isT <- second_snp == "T"
   isC <- second_snp == "C"
   isG <- second_snp == "G"
   
   microdiv_data$obsN[snps_by_row > 1][(isA & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 1][(isA & !OG_cod)]+microdiv_data$sub_samp_a[snps_by_row > 1][(isA & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 1][(isT & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 1][(isT & !OG_cod)]+microdiv_data$sub_samp_t[snps_by_row > 1][(isT & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 1][(isC & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 1][(isC & !OG_cod)]+microdiv_data$sub_samp_c[snps_by_row > 1][(isC & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 1][(isG & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 1][(isG & !OG_cod)]+microdiv_data$sub_samp_g[snps_by_row > 1][(isG & !OG_cod)]
   
   microdiv_data$obsS[snps_by_row > 1][(isA & OG_cod)] <- microdiv_data$obsS[snps_by_row > 1][(isA & OG_cod)]+microdiv_data$sub_samp_a[snps_by_row > 1][(isA & OG_cod)]
   microdiv_data$obsS[snps_by_row > 1][(isT & OG_cod)] <- microdiv_data$obsS[snps_by_row > 1][(isT & OG_cod)]+microdiv_data$sub_samp_t[snps_by_row > 1][(isT & OG_cod)]
   microdiv_data$obsS[snps_by_row > 1][(isC & OG_cod)] <- microdiv_data$obsS[snps_by_row > 1][(isC & OG_cod)]+microdiv_data$sub_samp_c[snps_by_row > 1][(isC & OG_cod)]
   microdiv_data$obsS[snps_by_row > 1][(isG & OG_cod)] <- microdiv_data$obsS[snps_by_row > 1][(isG & OG_cod)]+microdiv_data$sub_samp_g[snps_by_row > 1][(isG & OG_cod)]
   
   
   #Ibid. for 2, but with 3 alt alleles on one locus. This is the third allele.
   third_snp <- substr(microdiv_data$snps[snps_by_row > 2], 3, 3)
   OG_cod <- microdiv_data$original_codon[snps_by_row > 2]
   
   substr(OG_cod, microdiv_data$pos_in_codon[snps_by_row > 2], microdiv_data$pos_in_codon[snps_by_row > 2]) <- third_snp
   OG_cod <- proteinConstruct[match(OG_cod, construct)] == microdiv_data$original_AA[snps_by_row > 2]
   
   isA <- third_snp == "A"
   isT <- third_snp == "T"
   isC <- third_snp == "C"
   isG <- third_snp == "G"
   
   microdiv_data$obsN[snps_by_row > 2][(isA & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 2][(isA & !OG_cod)]+microdiv_data$sub_samp_a[snps_by_row > 2][(isA & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 2][(isT & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 2][(isT & !OG_cod)]+microdiv_data$sub_samp_t[snps_by_row > 2][(isT & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 2][(isC & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 2][(isC & !OG_cod)]+microdiv_data$sub_samp_c[snps_by_row > 2][(isC & !OG_cod)]
   microdiv_data$obsN[snps_by_row > 2][(isG & !OG_cod)] <- microdiv_data$obsN[snps_by_row > 2][(isG & !OG_cod)]+microdiv_data$sub_samp_g[snps_by_row > 2][(isG & !OG_cod)]
   
   microdiv_data$obsS[snps_by_row > 2][(isA & OG_cod)] <- microdiv_data$obsS[snps_by_row > 2][(isA & OG_cod)]+microdiv_data$sub_samp_a[snps_by_row > 2][(isA & OG_cod)]
   microdiv_data$obsS[snps_by_row > 2][(isT & OG_cod)] <- microdiv_data$obsS[snps_by_row > 2][(isT & OG_cod)]+microdiv_data$sub_samp_t[snps_by_row > 2][(isT & OG_cod)]
   microdiv_data$obsS[snps_by_row > 2][(isC & OG_cod)] <- microdiv_data$obsS[snps_by_row > 2][(isC & OG_cod)]+microdiv_data$sub_samp_c[snps_by_row > 2][(isC & OG_cod)]
   microdiv_data$obsS[snps_by_row > 2][(isG & OG_cod)] <- microdiv_data$obsS[snps_by_row > 2][(isG & OG_cod)]+microdiv_data$sub_samp_g[snps_by_row > 2][(isG & OG_cod)]
   
   rm(isA, isT, isC, isG, OG_cod, first_snp, second_snp, third_snp, snps_by_row)
   
   gm_mean = function(x){
      ceiling(exp(sum(log(x[x > 0]), na.rm=T) / length(x)))
   }
   
   
   {
      setkey(microdiv_data, "contig_gene")
      total_snps_genic <- microdiv_data[, list(length(unique(contig_pos)), unique(contig)), by = key(microdiv_data)]
      colnames(total_snps_genic)[2:3] = c("count", "contig")
      
      setkeyv(microdiv_data, c("contig_gene", "source"))
      gene_level_microdiv <- microdiv_data[, list(unique(contig), sum(pi, na.rm = T), length(contig), gm_mean(sub_samp_depth)), by=key(microdiv_data)]
      colnames(gene_level_microdiv)[3:6] = c("contig", "pi", "num_snps", "harmonic_number")
      
      #Shouldn't calculate microdiv if the depth is too low
      gene_level_microdiv <- gene_level_microdiv[harmonic_number > 2,]
      
      gene_level_microdiv$gene_len <- gene_assembly$length[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      gene_level_microdiv$theta <- (gene_level_microdiv$num_snps/harmonic[gene_level_microdiv$harmonic_number])/(gene_level_microdiv$gene_len-(total_snps_genic$count[match(gene_level_microdiv$contig_gene, total_snps_genic$contig_gene)]-gene_level_microdiv$num_snps))
      
      #Modify pi to follow SNP count corrections exactly like theta
      gene_level_microdiv$pi <- gene_level_microdiv$pi/(gene_level_microdiv$gene_len-(total_snps_genic$count[match(gene_level_microdiv$contig_gene, total_snps_genic$contig_gene)]-gene_level_microdiv$num_snps))
      
      gene_level_microdiv$taj_D <- (gene_level_microdiv$pi-(gene_level_microdiv$num_snps/harmonic[gene_level_microdiv$harmonic_number]))/sqrt((e1[gene_level_microdiv$harmonic_number]*gene_level_microdiv$num_snps)+(e2[gene_level_microdiv$harmonic_number]*gene_level_microdiv$num_snps*(gene_level_microdiv$num_snps-1)))
      
      
      #check it out to make sure this works
      gene_level_microdiv <- gene_level_microdiv[, -6]
      
      saved_total_snps_genic <- total_snps_genic
      
      # Repeated at the level of the codon; all of the data gets incorporated as well as possible
      total_snps_genic$contig_gene = NULL
      
      setkey(non_genic_data, "contig")
      total_snps <- non_genic_data[, length(unique(contig_pos)), by=key(non_genic_data)]
      names(total_snps)[2] = "count"
      
      total_snps <- rbind(total_snps_genic, total_snps)
      
      setkey(total_snps, "contig")
      total_snps <- total_snps[, sum(count), by=key(total_snps)]
      colnames(total_snps)[2] = "count"
      
      cleaned_data <- data.table(contig_pos = microdiv_data$contig_pos, contig = microdiv_data$contig, pi = microdiv_data$pi, source = microdiv_data$source, dep = microdiv_data$sub_samp_depth)
      cleaned_data <- rbind(cleaned_data, data.table(contig_pos = non_genic_data$contig_pos, contig = non_genic_data$contig, pi=non_genic_data$pi, source = non_genic_data$source, dep = non_genic_data$sub_samp_depth))
      
      setkeyv(cleaned_data, c("contig", "source"))
      
      extant_names <- unique(cleaned_data$source)
      contigs_with_real_observations_by_sc <- cleaned_data[,list(list(unique(contig))), by = source]$V1
      names(contigs_with_real_observations_by_sc) = extant_names
      
      #Finds the contigs that passed the cov/depth filter but had no passing SNPs. 
      #This is added to the contig_level_microdiv as the has_snps = FALSE section.
      contigs_with_no_snps_by_sample <- lapply(names(depth_info), function(x){
         
         #if a sample has passing contigs, but no SNPs, we want to return all passing contigs in the depth file
         if(is.null(contigs_with_real_observations_by_sc[[x]])){
            return(depth_info[[x]])
         }else{
            #Else return all of the contigs that aren't in the data already - i.e. the SNPless ones.
            return(depth_info[[x]][!(V1 %in% contigs_with_real_observations_by_sc[[x]])])
         }
         
      })
      names(contigs_with_no_snps_by_sample) = names(depth_info)
      
      #Empty ones are fully covered already
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[unlist(lapply(contigs_with_no_snps_by_sample, nrow)) > 0]
      
      gene_depth_info <- rbindlist(lapply(names(depth_info), function(x){
         
         tmp <- gene_assembly[contig %in% depth_info[[x]]$V1, list(OC, gene, contig, length, expN, expS)]
         tmp$source <- x
         return(tmp)
         
      }))
      
      contig_level_microdiv <- cleaned_data[,list(sum(pi, na.rm=T), length(contig_pos), gm_mean(dep)), by=key(cleaned_data)]
      colnames(contig_level_microdiv)[3:5] = c("pi", "num_snps", "harmonic_number")
      
      #can't calc. taj. D if sample depth < 2, and SHOULDN'T unless it's 3.
      contig_level_microdiv <- contig_level_microdiv[harmonic_number > 2,]
      
      contig_level_microdiv$contig_len <- assembled_contigs$length[match(contig_level_microdiv$contig, assembled_contigs$contig)]
      contig_level_microdiv$theta <- (contig_level_microdiv$num_snps/harmonic[contig_level_microdiv$harmonic_number])/(contig_level_microdiv$contig_len-(total_snps$count[match(contig_level_microdiv$contig, total_snps$contig)]-contig_level_microdiv$num_snps))
      
      #Modify pi to follow SNP cpount corrections exactly like theta
      contig_level_microdiv$pi <- contig_level_microdiv$pi/(contig_level_microdiv$contig_len-(total_snps$count[match(contig_level_microdiv$contig, total_snps$contig)]-contig_level_microdiv$num_snps))
      
      contig_level_microdiv <- contig_level_microdiv[, -5]
      
      #If linked SNPs was done, corrects the microdiv_data for the directly observed read results
      if(dir.exists("MetaPop/09.Linked_SNPs")){
         print("Correcting subsamples for linked snps")
         
         mined_reads <- fread("MetaPop/09.Linked_SNPs/linked_snp_results.tsv", sep = "\t")
         
         mined_reads <- mined_reads[(mined_reads$ref_first+mined_reads$ref_count+mined_reads$snp_count+mined_reads$ref_second)>0,]
         
         mined_reads$original_codon <- mapply(function(codons, index){
            return(codons[index])
         },
         split_codons[match(mined_reads$contig_gene, gene_assembly$gene)], mined_reads$codon)
         
         mined_reads <- mined_reads[mined_reads$original_codon %in% construct,]
         
         has_alts <- grepl("[*]", mined_reads$refs)
         
         #We need to get the partial alts here for N/S
         mined_reads$alt1 <- mapply(function(read, alt, correct, is_alt){
            
            #We neither need to nor should find alts for triples; they are taken care of as part of their 2-part subsets.
            if(!is_alt){
               return("")
            }
            
            str <- strsplit(read, split="")[[1]]
            snp <- strsplit(alt, split="")[[1]]
            cor <- strsplit(correct, split="")[[1]]
            
            pos <- which(str == "*")
            
            if(pos == 1){
               hybrid <- c(cor[pos], str[pos+1], snp[pos+2])
            }
            
            if(pos == 2){
               hybrid <- c(str[pos-1], cor[pos], snp[pos+1])
            }
            
            if(pos == 3){
               hybrid <- c(str[pos-2], snp[pos-1], cor[pos])
            }
            
            hybrid <- paste0(hybrid, collapse = "")
            
            
            return(hybrid)
            
         }, mined_reads$refs, mined_reads$snp, mined_reads$original_codon, has_alts)
         mined_reads$alt2 <- mapply(function(read, alt, correct, is_alt){
            
            #We neither need to nor should find alts for triples; they are taken care of as part of their 2-part subsets.
            if(!is_alt){
               return("")
            }
            
            str <- strsplit(read, split="")[[1]]
            snp <- strsplit(alt, split="")[[1]]
            cor <- strsplit(correct, split="")[[1]]
            
            pos <- which(str == "*")
            
            if(pos == 1){
               hybrid <- c(cor[pos], snp[pos+1], str[pos+2])
            }
            
            if(pos == 2){
               hybrid <- c(snp[pos-1], cor[pos], str[pos+1])
            }
            
            if(pos == 3){
               hybrid <- c(snp[pos-2], str[pos-1], cor[pos])
            }
            
            hybrid <- paste0(hybrid, collapse = "")
            
            
            return(hybrid)
            
         }, mined_reads$refs, mined_reads$snp, mined_reads$original_codon, has_alts)
         
         mined_reads$refs <- mapply(function(read, correct){
            
            str <- strsplit(read, split="")[[1]]
            if(any(str == "*")){
               pos <- which(str == "*")
               cor <- strsplit(correct, split="")[[1]]
               str[pos] <- cor[pos]
               read <- paste0(str, collapse = "")
            }
            return(read)
            
         }, mined_reads$refs, mined_reads$original_codon)
         #This is the codon with all SNPs present - i.e. 2 or 3 SNPs on the same codon simultaneously
         mined_reads$snp <- mapply(function(read, correct){
            
            str <- strsplit(read, split="")[[1]]
            if(any(str == "*")){
               pos <- which(str == "*")
               cor <- strsplit(correct, split="")[[1]]
               str[pos] <- cor[pos]
               read <- paste0(str, collapse = "")
            }
            return(read)
            
         }, mined_reads$snp, mined_reads$original_codon)
         
         setkeyv(mined_reads, c("source", "contig_gene", "codon"))
         mined_reads[, overall_prop := sum(ref_count+snp_count+ref_first+ref_second), by = key(mined_reads)]
         mined_reads$overall_prop <- sub_samp/mined_reads$overall_prop
         
         #If there were invalid codons, e.g. TAN, GNN, NNN, etc. where there is a missing base, mistakes may occur. This cleans them out.
         mined_reads <- mined_reads[nchar(alt1)>0 & nchar(alt2)>0 & nchar(refs)>0 & nchar(snp)>0,]
         
         mined_reads[, ref_count := ifelse(overall_prop < 1, round(ref_count*overall_prop), ref_count) , by = .I]
         mined_reads[, snp_count := ifelse(overall_prop < 1, round(snp_count*overall_prop), snp_count) , by = .I]
         mined_reads[, ref_first := ifelse(overall_prop < 1, round(ref_first*overall_prop), ref_first) , by = .I]
         mined_reads[, ref_second := ifelse(overall_prop < 1, round(ref_second*overall_prop), ref_second) , by = .I]
         
         #original codon doesn't contribute
         mined_reads$ref_count <- 0
         
         mined_reads$orignal_AA <- proteinConstruct[match(mined_reads$original_codon, construct)]
         
         mined_reads$ref_AA <- proteinConstruct[match(mined_reads$refs, construct)]
         mined_reads$snp_AA <- proteinConstruct[match(mined_reads$snp, construct)]
         mined_reads$alt1_AA <- proteinConstruct[match(mined_reads$alt1, construct)]
         mined_reads$alt2_AA <- proteinConstruct[match(mined_reads$alt2, construct)]
         
         mined_reads$obsN <- 0
         mined_reads$obsN <- ifelse(mined_reads$snp_AA==mined_reads$ref_AA, mined_reads$obsN, mined_reads$obsN+mined_reads$snp_count)
         mined_reads$obsN <- ifelse(mined_reads$alt1_AA==mined_reads$ref_AA, mined_reads$obsN, mined_reads$obsN+mined_reads$ref_first)
         mined_reads$obsN <- ifelse(mined_reads$alt2_AA==mined_reads$ref_AA, mined_reads$obsN, mined_reads$obsN+mined_reads$ref_second)
         
         mined_reads$obsS <- 0
         mined_reads$obsS <- ifelse(mined_reads$snp_AA!=mined_reads$ref_AA, mined_reads$obsS, mined_reads$obsS+mined_reads$snp_count)
         mined_reads$obsS <- ifelse(mined_reads$alt1_AA!=mined_reads$ref_AA, mined_reads$obsS, mined_reads$obsS+mined_reads$ref_first)
         mined_reads$obsS <- ifelse(mined_reads$alt2_AA!=mined_reads$ref_AA, mined_reads$obsS, mined_reads$obsS+mined_reads$ref_second)
         
         mined_reads <- mined_reads[, list(obsN = sum(obsN, na.rm=T), obsS = sum(obsS, na.rm=T), ref = unique(refs)), by = key(mined_reads)]
         
         mined_reads$obsN <- ifelse(mined_reads$obsN+mined_reads$obsS>sub_samp, round((mined_reads$obsN/(mined_reads$obsN+mined_reads$obsS))*sub_samp), mined_reads$obsN)
         mined_reads$obsS <- ifelse(mined_reads$obsN+mined_reads$obsS>sub_samp, round((mined_reads$obsS/(mined_reads$obsN+mined_reads$obsS))*sub_samp), mined_reads$obsS)
         
         microdiv_data$match_key <- paste0(microdiv_data$source, microdiv_data$contig_gene, microdiv_data$codon)
         mined_reads$match_key <- paste0(mined_reads$source, mined_reads$contig_gene, mined_reads$codon)
         
         mined_reads <- mined_reads[mined_reads$match_key %in% microdiv_data$match_key,]
         
         selector <- microdiv_data$match_key %in% mined_reads$match_key
         
         #sets counts on each codon for microdiv data to zero to prevent double counting; sets codons to blank for correcting
         
         microdiv_data[, obsN := ifelse(selector, 0, obsN)]
         microdiv_data[, obsS := ifelse(selector, 0, obsS)]
         
         microdiv_data[, affected_by_linked_snps := F]
         microdiv_data[, affected_by_linked_snps := ifelse(selector, T, F)]
         
         selector <- match(mined_reads$match_key, microdiv_data$match_key)
         
         #sets only the first row for each codon with linked data to have the linked data values
         microdiv_data$obsN[selector] <- mined_reads$obsN
         microdiv_data$obsS[selector] <- mined_reads$obsS
         #microdiv_data$original_codon[selector] <- mined_reads$ref
         
         microdiv_data[,match_key:=NULL]
         
      }else{
         print("Linked SNPs corrections not performed; pNpS results may NOT be fully accurate.")
      }
      
      setkeyv(microdiv_data, c("contig_gene", "source"))
      pnps <- microdiv_data[, list(sum(obsN), sum(obsS)), by = key(microdiv_data)]
      colnames(pnps)[3:4] = c("obsN", "obsS") 
      
      gene_level_microdiv$expN <- gene_assembly$expN[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      gene_level_microdiv$expS <- gene_assembly$expS[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      
      pnps[, match_key := paste0(contig_gene, source),]
      gene_level_microdiv[, key := paste0(contig_gene, source)]
      
      gene_level_microdiv$obsN <- pnps$obsN[match(gene_level_microdiv$key, pnps$match_key)]
      gene_level_microdiv$obsS <- pnps$obsS[match(gene_level_microdiv$key, pnps$match_key)]
      
      #Calculating pNpS ratio
      gene_level_microdiv$pNpS_ratio <- (gene_level_microdiv$obsN/gene_level_microdiv$obsS)/(gene_level_microdiv$expN/gene_level_microdiv$expS)
      
      contig_level_microdiv[,snps_present := T]
      gene_level_microdiv[,snps_present := T]
      
      #Fix up the contigs w/o snps to match the form of the contigs with snps
      contigs_with_no_snps_by_sample <- rbindlist(contigs_with_no_snps_by_sample)
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[,list(V1, source, V2)]
      colnames(contigs_with_no_snps_by_sample)[c(1,3)] = c("contig", "contig_len")
      contigs_with_no_snps_by_sample[, pi := 0]
      contigs_with_no_snps_by_sample[, num_snps := 0]
      contigs_with_no_snps_by_sample[, theta := 0]
      contigs_with_no_snps_by_sample[, snps_present := FALSE]
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[, list(contig, source, pi, num_snps, contig_len, theta, snps_present)]
      
      #Bind the samples together.
      contig_level_microdiv <- rbindlist(list(contig_level_microdiv, contigs_with_no_snps_by_sample))
      
      gene_depth_info[, key := paste0(gene, source)]
      gene_depth_info <- gene_depth_info[!(key %in% gene_level_microdiv$key),]
      
      gene_depth_info[, key := NULL]
      gene_level_microdiv[, key := NULL]
      
      #fix up the missing genes to match the form of the genes with snps
      gene_depth_info[, pi := 0]
      gene_depth_info[, num_snps := 0]
      gene_depth_info[, obsN := 0]
      gene_depth_info[, obsS := 0]
      gene_depth_info[, theta := 0]
      gene_depth_info[, taj_D := 0]
      gene_depth_info[, pNpS_ratio := 0]
      gene_depth_info[, snps_present := FALSE]
      
      gene_depth_info <- gene_depth_info[, list(gene, source, contig, pi, num_snps, length, theta, taj_D, expN, expS, obsN, obsS, pNpS_ratio, snps_present)]
      colnames(gene_depth_info) = colnames(gene_level_microdiv)
      
      gene_level_microdiv <- rbindlist(list(gene_level_microdiv, gene_depth_info))
      
      
      
      fwrite(microdiv_data, "MetaPop/10.Microdiversity/global_raw_microdiversity_data_snp_loci_only.tsv", sep = "\t")
      
      fwrite(gene_level_microdiv, "MetaPop/10.Microdiversity/global_gene_microdiversity.tsv", sep = "\t")
      fwrite(contig_level_microdiv, "MetaPop/10.Microdiversity/global_contig_microdiversity.tsv", sep = "\t")
      
      fwrite(codon_pos_count, "MetaPop/10.Microdiversity/global_codon_position_summary.tsv", sep = "\t")
      
   }
   
   if(sum(codon_pos_count$third_pos) < sum(codon_pos_count$second_pos) | sum(codon_pos_count$third_pos) < sum(codon_pos_count$first_pos)){
      print("More SNPs were observed in either the first or second positions of codons than in the third position. This is suspicious, and results should be treated cautiously.")
      flush.console()
   }
   
   
   #Local level stuff
   vcfs <- list.files(path = "MetaPop/05.Variant_Calls", full.names = T)
   
   cl <- makeCluster(min(threads, detectCores(), length(vcfs)))
   registerDoParallel(cl)
   clusterExport(cl, c("library_location", "vcfs"))
   clusterEvalQ(cl=cl, expr = library(data.table, lib.loc = library_location))
   
   # Read and process mpileup files in parallel
   vcf_sums <- foreach(i=vcfs) %dopar%{
      tmp <- fread(i, sep = "\t", col.names = c("contig", "pos", "ref", "alt"))
      tmp[, source := substr(i, 26, nchar(i)-17)]
      tmp[, key := paste0(contig,"_", pos, source)]
      
      return(tmp)
   }
   
   stopCluster(cl)
   
   vcf_sums <- rbindlist(vcf_sums)
   
   
   microdiv_data[, key := paste0(contig_pos, source)]
   
   microdiv_data_local <- microdiv_data[key %in% vcf_sums$key,]
   
   {
      setkey(microdiv_data_local, "contig_gene")
      total_snps_genic <- microdiv_data_local[, list(length(unique(contig_pos)), unique(contig)), by = key(microdiv_data_local)]
      colnames(total_snps_genic)[2:3] = c("count", "contig")
      
      setkeyv(microdiv_data_local, c("contig_gene", "source"))
      gene_level_microdiv <- microdiv_data_local[, list(unique(contig), sum(pi, na.rm = T), length(contig), gm_mean(sub_samp_depth)), by=key(microdiv_data_local)]
      colnames(gene_level_microdiv)[3:6] = c("contig", "pi", "num_snps", "harmonic_number")
      
      #Shouldn't calculate microdiv if the depth is too low
      gene_level_microdiv <- gene_level_microdiv[harmonic_number > 2,]
      
      gene_level_microdiv$gene_len <- gene_assembly$length[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      gene_level_microdiv$theta <- (gene_level_microdiv$num_snps/harmonic[gene_level_microdiv$harmonic_number])/(gene_level_microdiv$gene_len-(total_snps_genic$count[match(gene_level_microdiv$contig_gene, total_snps_genic$contig_gene)]-gene_level_microdiv$num_snps))
      
      #Modify pi to follow SNP count corrections exactly like theta
      gene_level_microdiv$pi <- gene_level_microdiv$pi/(gene_level_microdiv$gene_len-(total_snps_genic$count[match(gene_level_microdiv$contig_gene, total_snps_genic$contig_gene)]-gene_level_microdiv$num_snps))
      
      gene_level_microdiv$taj_D <- (gene_level_microdiv$pi-(gene_level_microdiv$num_snps/harmonic[gene_level_microdiv$harmonic_number]))/sqrt((e1[gene_level_microdiv$harmonic_number]*gene_level_microdiv$num_snps)+(e2[gene_level_microdiv$harmonic_number]*gene_level_microdiv$num_snps*(gene_level_microdiv$num_snps-1)))
      
      
      #check it out to make sure this works
      gene_level_microdiv <- gene_level_microdiv[, -6]
      
      saved_total_snps_genic <- total_snps_genic
      
      # Repeated at the level of the codon; all of the data gets incorporated as well as possible
      total_snps_genic$contig_gene = NULL
      
      setkey(non_genic_data, "contig")
      total_snps <- non_genic_data[, length(unique(contig_pos)), by=key(non_genic_data)]
      names(total_snps)[2] = "count"
      
      total_snps <- rbind(total_snps_genic, total_snps)
      
      setkey(total_snps, "contig")
      total_snps <- total_snps[, sum(count), by=key(total_snps)]
      colnames(total_snps)[2] = "count"
      
      cleaned_data <- data.table(contig_pos = microdiv_data_local$contig_pos, contig = microdiv_data_local$contig, pi = microdiv_data_local$pi, source = microdiv_data_local$source, dep = microdiv_data_local$sub_samp_depth)
      cleaned_data <- rbind(cleaned_data, data.table(contig_pos = non_genic_data$contig_pos, contig = non_genic_data$contig, pi=non_genic_data$pi, source = non_genic_data$source, dep = non_genic_data$sub_samp_depth))
      
      setkeyv(cleaned_data, c("contig", "source"))
      
      extant_names <- unique(cleaned_data$source)
      contigs_with_real_observations_by_sc <- cleaned_data[,list(list(unique(contig))), by = source]$V1
      names(contigs_with_real_observations_by_sc) = extant_names
      
      #Finds the contigs that passed the cov/depth filter but had no passing SNPs. 
      #This is added to the contig_level_microdiv as the has_snps = FALSE section.
      contigs_with_no_snps_by_sample <- lapply(names(depth_info), function(x){
         
         #if a sample has passing contigs, but no SNPs, we want to return all passing contigs in the depth file
         if(is.null(contigs_with_real_observations_by_sc[[x]])){
            return(depth_info[[x]])
         }else{
            #Else return all of the contigs that aren't in the data already - i.e. the SNPless ones.
            return(depth_info[[x]][!(V1 %in% contigs_with_real_observations_by_sc[[x]])])
         }
         
      })
      names(contigs_with_no_snps_by_sample) = names(depth_info)
      
      #Empty ones are fully covered already
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[unlist(lapply(contigs_with_no_snps_by_sample, nrow)) > 0]
      
      gene_depth_info <- rbindlist(lapply(names(depth_info), function(x){
         
         tmp <- gene_assembly[contig %in% depth_info[[x]]$V1, list(OC, gene, contig, length, expN, expS)]
         tmp$source <- x
         return(tmp)
         
      }))
      
      contig_level_microdiv <- cleaned_data[,list(sum(pi, na.rm=T), length(contig_pos), gm_mean(dep)), by=key(cleaned_data)]
      colnames(contig_level_microdiv)[3:5] = c("pi", "num_snps", "harmonic_number")
      
      #can't calc. taj. D if sample depth < 2, and SHOULDN'T unless it's 3.
      contig_level_microdiv <- contig_level_microdiv[harmonic_number > 2,]
      
      contig_level_microdiv$contig_len <- assembled_contigs$length[match(contig_level_microdiv$contig, assembled_contigs$contig)]
      contig_level_microdiv$theta <- (contig_level_microdiv$num_snps/harmonic[contig_level_microdiv$harmonic_number])/(contig_level_microdiv$contig_len-(total_snps$count[match(contig_level_microdiv$contig, total_snps$contig)]-contig_level_microdiv$num_snps))
      
      #Modify pi to follow SNP cpount corrections exactly like theta
      contig_level_microdiv$pi <- contig_level_microdiv$pi/(contig_level_microdiv$contig_len-(total_snps$count[match(contig_level_microdiv$contig, total_snps$contig)]-contig_level_microdiv$num_snps))
      
      contig_level_microdiv <- contig_level_microdiv[, -5]
      
      #Fixed up to linked. Fantastic, time to do THIS...
      #If linked SNPs was done, corrects the microdiv_data_local for the directly observed read results
      if(dir.exists("MetaPop/09.Linked_SNPs")){
         print("Correcting local subsamples for linked snps")
         
         microdiv_data_local$match_key <- paste0(microdiv_data_local$source, microdiv_data_local$contig_gene, microdiv_data_local$codon)
         mined_reads$match_key <- paste0(mined_reads$source, mined_reads$contig_gene, mined_reads$codon)
         
         mined_reads <- mined_reads[mined_reads$match_key %in% microdiv_data_local$match_key,]
         
         selector <- microdiv_data_local$match_key %in% mined_reads$match_key
         
         #sets counts on each codon for microdiv data to zero to prevent double counting; sets codons to blank for correcting
         
         microdiv_data_local[, obsN := ifelse(selector, 0, obsN)]
         microdiv_data_local[, obsS := ifelse(selector, 0, obsS)]
         
         microdiv_data_local[, affected_by_linked_snps := F]
         
         selector <- match(mined_reads$match_key, microdiv_data_local$match_key)
         
         #sets only the first row for each codon with linked data to have the linked data values
         microdiv_data_local$obsN[selector] <- mined_reads$obsN
         microdiv_data_local$obsS[selector] <- mined_reads$obsS
         #microdiv_data_local$original_codon[selector] <- mined_reads$ref
         
         microdiv_data_local[,match_key:=NULL]
         
      }else{
         print("Linked SNPs corrections not performed; pNpS results may NOT be fully accurate.")
         print("We recommend running MetaPop_Mine_Reads.R before the microdiversity module to correct SNP data over reads.")
      }
      
      setkeyv(microdiv_data_local, c("contig_gene", "source"))
      pnps <- microdiv_data_local[, list(sum(obsN), sum(obsS)), by = key(microdiv_data_local)]
      colnames(pnps)[3:4] = c("obsN", "obsS") 
      
      gene_level_microdiv$expN <- gene_assembly$expN[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      gene_level_microdiv$expS <- gene_assembly$expS[match(gene_level_microdiv$contig_gene, gene_assembly$gene)]
      
      pnps[, match_key := paste0(contig_gene, source),]
      gene_level_microdiv[, key := paste0(contig_gene, source)]
      
      gene_level_microdiv$obsN <- pnps$obsN[match(gene_level_microdiv$key, pnps$match_key)]
      gene_level_microdiv$obsS <- pnps$obsS[match(gene_level_microdiv$key, pnps$match_key)]
      
      #Calculating pNpS ratio
      gene_level_microdiv$pNpS_ratio <- (gene_level_microdiv$obsN/gene_level_microdiv$obsS)/(gene_level_microdiv$expN/gene_level_microdiv$expS)
      
      contig_level_microdiv[,snps_present := T]
      gene_level_microdiv[,snps_present := T]
      
      #Fix up the contigs w/o snps to match the form of the contigs with snps
      contigs_with_no_snps_by_sample <- rbindlist(contigs_with_no_snps_by_sample)
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[,list(V1, source, V2)]
      colnames(contigs_with_no_snps_by_sample)[c(1,3)] = c("contig", "contig_len")
      contigs_with_no_snps_by_sample[, pi := 0]
      contigs_with_no_snps_by_sample[, num_snps := 0]
      contigs_with_no_snps_by_sample[, theta := 0]
      contigs_with_no_snps_by_sample[, snps_present := FALSE]
      contigs_with_no_snps_by_sample <- contigs_with_no_snps_by_sample[, list(contig, source, pi, num_snps, contig_len, theta, snps_present)]
      
      #Bind the samples together.
      contig_level_microdiv <- rbindlist(list(contig_level_microdiv, contigs_with_no_snps_by_sample))
      
      gene_depth_info[, key := paste0(gene, source)]
      gene_depth_info <- gene_depth_info[!(key %in% gene_level_microdiv$key),]
      
      gene_depth_info[, key := NULL]
      gene_level_microdiv[, key := NULL]
      
      #fix up the missing genes to match the form of the genes with snps
      gene_depth_info[, pi := 0]
      gene_depth_info[, num_snps := 0]
      gene_depth_info[, obsN := 0]
      gene_depth_info[, obsS := 0]
      gene_depth_info[, theta := 0]
      gene_depth_info[, taj_D := 0]
      gene_depth_info[, pNpS_ratio := 0]
      gene_depth_info[, snps_present := FALSE]
      
      gene_depth_info <- gene_depth_info[, list(gene, source, contig, pi, num_snps, length, theta, taj_D, expN, expS, obsN, obsS, pNpS_ratio, snps_present)]
      colnames(gene_depth_info) = colnames(gene_level_microdiv)
      
      gene_level_microdiv <- rbindlist(list(gene_level_microdiv, gene_depth_info))
      
      fwrite(microdiv_data_local, "MetaPop/10.Microdiversity/local_raw_microdiversity_data_snp_loci_only.tsv", sep = "\t")
      
      fwrite(gene_level_microdiv, "MetaPop/10.Microdiversity/local_gene_microdiversity.tsv", sep = "\t")
      fwrite(contig_level_microdiv, "MetaPop/10.Microdiversity/local_contig_microdiversity.tsv", sep = "\t")
      
      fwrite(codon_pos_count, "MetaPop/10.Microdiversity/local_codon_position_summary.tsv", sep = "\t")
      
   }
   

options <- commandArgs(trailingOnly = T)

dir = options[1]

gene_file <- options[2]

if(length(options)>2){
library_location <- options[3]
}

if(library_location == ""){
  library_location <- .libPaths()
}

suppressMessages(suppressWarnings(library(data.table, lib.loc = library_location)))

genes = readLines(gene_file)

setwd(dir)

gene_locs = which(substr(genes, 1, 1) == ">")
gene_headers = genes[gene_locs]
genes[gene_locs] = ""
gene_headers = unlist(lapply(gene_headers, function(x){
  name = strsplit(x, " # ")[[1]][1]
  name = substr(name, 2, nchar(name))
  return(name)
}))

sizes = (gene_locs[2:length(gene_locs)] - gene_locs[1:(length(gene_locs)-1)])
#Append final index
sizes = c(sizes, length(genes)-gene_locs[length(gene_locs)]+1)

splits = rep(1:length(gene_headers), times = sizes)

gsplit = split(genes, splits)

construct <- c("AAA", "AAT", "AAC", "AAG",
               "ATA", "ATT", "ATC", "ATG",
               "ACA", "ACT", "ACC", "ACG",
               "AGA", "AGT", "AGC", "AGG",
               
               "TAA", "TAT", "TAC", "TAG",
               "TTA", "TTT", "TTC", "TTG",
               "TCA", "TCT", "TCC", "TCG",
               "TGA", "TGT", "TGC", "TGG",
               
               "CAA", "CAT", "CAC", "CAG",
               "CTA", "CTT", "CTC", "CTG",
               "CCA", "CCT", "CCC", "CCG",
               "CGA", "CGT", "CGC", "CGG",
               
               "GAA", "GAT", "GAC", "GAG",
               "GTA", "GTT", "GTC", "GTG",
               "GCA", "GCT", "GCC", "GCG",
               "GGA", "GGT", "GGC", "GGG")

codon_data = data.table(matrix(unlist(lapply(gsplit, (function(x){
  #Combine the seq into a single string
  seq = paste(x, collapse = "")
  #split to chars
  seq = unlist(strsplit(seq, split = ""))
  #recombine to codons
  seq = paste0(seq[c(T,F,F)], seq[c(F,T,F)], seq[c(F,F,T)])
  #count the occurrences of each codon
  seq = table(seq)
  
  #create a named, ordered list of 64 counts exactly matching the order of construct
  counts = rep(0, 64)
  names(counts) = construct
  
  #fill the appropriate, ordred counts with the real data, leaving zeroes elsewhere.
  counts[names(seq)] = seq
  
  #print(length(counts))
  
  #return the ordered count data
  return(counts)
  
}))), ncol = 64))


genes = data.table(V1 = gene_headers)
rm(gene_locs, sizes, splits, gsplit, gene_headers)
genes[, V2 := gsub('_\\d+$', '', genes$V1), ]


#genes <- fread("MetaPop/08.Codon_Bias/codon_bias_sequences.tsv", sep = "\t", header = F, select = c(3,4))
colnames(genes) = c("V1", "V2")

#codon_data <- fread("MetaPop/08.Codon_Bias/codon_counts_by_gene.tsv", sep = "\t", header = F)
colnames(codon_data) = construct

#We have to get the proportion that each codon contributes to the AA by AA; split exaple on isoleucine ATT ATC ATA proportions;
I <- codon_data$ATT + codon_data$ATC + codon_data$ATA
L <- codon_data$CTT + codon_data$CTC + codon_data$CTA + codon_data$CTG + codon_data$TTA + codon_data$TTG
V <- codon_data$GTT + codon_data$GTC + codon_data$GTA + codon_data$GTG
FE <- codon_data$TTT + codon_data$TTC
C <- codon_data$TGT + codon_data$TGC
A <- codon_data$GCT + codon_data$GCC + codon_data$GCA + codon_data$GCG
G <- codon_data$GGT + codon_data$GGC + codon_data$GGA + codon_data$GGG
P <- codon_data$CCT + codon_data$CCC + codon_data$CCA + codon_data$CCG
TH <- codon_data$ACT + codon_data$ACC + codon_data$ACA + codon_data$ACG
S <- codon_data$TCT + codon_data$TCC + codon_data$TCA + codon_data$TCG + codon_data$AGT + codon_data$AGC
Y <- codon_data$TAT + codon_data$TAC
Q <- codon_data$CAA + codon_data$CAG
N <- codon_data$AAT + codon_data$AAC
H <- codon_data$CAT + codon_data$CAC
E <- codon_data$GAA + codon_data$GAG
D <- codon_data$GAT + codon_data$GAC
K <- codon_data$AAA + codon_data$AAG
R <- codon_data$CGT + codon_data$CGC + codon_data$CGA + codon_data$CGG + codon_data$AGA + codon_data$AGG
ST<- codon_data$TAA + codon_data$TAG + codon_data$TGA

#Now get their relative proportions
#Based on the standard codon <-> AA table, not microbial codon usage
rel_props <- data.table(codon_data$AAA/K,
                        codon_data$AAT/N,
                        codon_data$AAC/N,
                        codon_data$AAG/K,
                        
                        codon_data$ATA/I,
                        codon_data$ATT/I,
                        codon_data$ATC/I,
                        #start codon
                        1,
                        
                        codon_data$ACA/TH,
                        codon_data$ACT/TH,
                        codon_data$ACC/TH,
                        codon_data$ACG/TH,
                        
                        codon_data$AGA/R,
                        codon_data$AGT/S,
                        codon_data$AGC/S,
                        codon_data$AGG/R,
                        
                        codon_data$TAA/ST,
                        codon_data$TAT/Y,
                        codon_data$TAC/Y,
                        codon_data$TAG/ST,
                        
                        codon_data$TTA/L,
                        codon_data$TTT/FE,
                        codon_data$TTC/FE,
                        codon_data$TTG/L,
                        
                        codon_data$TCA/S,
                        codon_data$TCT/S,
                        codon_data$TCC/S,
                        codon_data$TCG/S,
                        
                        codon_data$TGA/ST,
                        codon_data$TGT/C,
                        codon_data$TGC/C,
                        #tryptophan
                        1,
                        
                        codon_data$CAA/Q,
                        codon_data$CAT/H,
                        codon_data$CAC/H,
                        codon_data$CAG/Q,
                        
                        codon_data$CTA/L,
                        codon_data$CTT/L,
                        codon_data$CTC/L,
                        codon_data$CTG/L,
                        
                        codon_data$CCA/P,
                        codon_data$CCT/P,
                        codon_data$CCC/P,
                        codon_data$CCG/P,
                        
                        codon_data$CGA/R,
                        codon_data$CGT/R,
                        codon_data$CGC/R,
                        codon_data$CGG/R,
                        
                        codon_data$GAA/E,
                        codon_data$GAT/D,
                        codon_data$GAC/D,
                        codon_data$GAG/E,
                        
                        codon_data$GTA/V,
                        codon_data$GTT/V,
                        codon_data$GTC/V,
                        codon_data$GTG/V,
                        
                        codon_data$GCA/A,
                        codon_data$GCT/A,
                        codon_data$GCC/A,
                        codon_data$GCG/A,
                        
                        codon_data$GGA/G,
                        codon_data$GGT/G,
                        codon_data$GGC/G,
                        codon_data$GGG/G)

colnames(rel_props) = construct

codon_data$parent_contig <- genes$V2

is.nan.data.frame <- function(x)
  do.call(cbind, lapply(x, is.nan))

rel_props[is.nan(rel_props)] <- 0

rel_props$parent_contig <- genes$V2

setkey(codon_data, "parent_contig")
mean_genes <- codon_data[, lapply(.SD, sum), key(codon_data)]

I <- mean_genes$ATT + mean_genes$ATC + mean_genes$ATA
L <- mean_genes$CTT + mean_genes$CTC + mean_genes$CTA + mean_genes$CTG + mean_genes$TTA + mean_genes$TTG
V <- mean_genes$GTT + mean_genes$GTC + mean_genes$GTA + mean_genes$GTG
FE <- mean_genes$TTT + mean_genes$TTC
C <- mean_genes$TGT + mean_genes$TGC
A <- mean_genes$GCT + mean_genes$GCC + mean_genes$GCA + mean_genes$GCG
G <- mean_genes$GGT + mean_genes$GGC + mean_genes$GGA + mean_genes$GGG
P <- mean_genes$CCT + mean_genes$CCC + mean_genes$CCA + mean_genes$CCG
TH <- mean_genes$ACT + mean_genes$ACC + mean_genes$ACA + mean_genes$ACG
S <- mean_genes$TCT + mean_genes$TCC + mean_genes$TCA + mean_genes$TCG + mean_genes$AGT + mean_genes$AGC
Y <- mean_genes$TAT + mean_genes$TAC
Q <- mean_genes$CAA + mean_genes$CAG
N <- mean_genes$AAT + mean_genes$AAC
H <- mean_genes$CAT + mean_genes$CAC
E <- mean_genes$GAA + mean_genes$GAG
D <- mean_genes$GAT + mean_genes$GAC
K <- mean_genes$AAA + mean_genes$AAG
R <- mean_genes$CGT + mean_genes$CGC + mean_genes$CGA + mean_genes$CGG + mean_genes$AGA + mean_genes$AGG
ST<- mean_genes$TAA + mean_genes$TAG + mean_genes$TGA


rel_props_mean_gene <- data.table(mean_genes$AAA/K,
                                  mean_genes$AAT/N,
                                  mean_genes$AAC/N,
                                  mean_genes$AAG/K,
                                  
                                  mean_genes$ATA/I,
                                  mean_genes$ATT/I,
                                  mean_genes$ATC/I,
                                  1,
                                  
                                  mean_genes$ACA/TH,
                                  mean_genes$ACT/TH,
                                  mean_genes$ACC/TH,
                                  mean_genes$ACG/TH,
                                  
                                  mean_genes$AGA/R,
                                  mean_genes$AGT/S,
                                  mean_genes$AGC/S,
                                  mean_genes$AGG/R,
                                  
                                  mean_genes$TAA/ST,
                                  mean_genes$TAT/Y,
                                  mean_genes$TAC/Y,
                                  mean_genes$TAG/ST,
                                  
                                  mean_genes$TTA/L,
                                  mean_genes$TTT/FE,
                                  mean_genes$TTC/FE,
                                  mean_genes$TTG/L,
                                  
                                  mean_genes$TCA/S,
                                  mean_genes$TCT/S,
                                  mean_genes$TCC/S,
                                  mean_genes$TCG/S,
                                  
                                  mean_genes$TGA/ST,
                                  mean_genes$TGT/C,
                                  mean_genes$TGC/C,
                                  1,
                                  
                                  mean_genes$CAA/Q,
                                  mean_genes$CAT/H,
                                  mean_genes$CAC/H,
                                  mean_genes$CAG/Q,
                                  
                                  mean_genes$CTA/L,
                                  mean_genes$CTT/L,
                                  mean_genes$CTC/L,
                                  mean_genes$CTG/L,
                                  
                                  mean_genes$CCA/P,
                                  mean_genes$CCT/P,
                                  mean_genes$CCC/P,
                                  mean_genes$CCG/P,
                                  
                                  mean_genes$CGA/R,
                                  mean_genes$CGT/R,
                                  mean_genes$CGC/R,
                                  mean_genes$CGG/R,
                                  
                                  mean_genes$GAA/E,
                                  mean_genes$GAT/D,
                                  mean_genes$GAC/D,
                                  mean_genes$GAG/E,
                                  
                                  mean_genes$GTA/V,
                                  mean_genes$GTT/V,
                                  mean_genes$GTC/V,
                                  mean_genes$GTG/V,
                                  
                                  mean_genes$GCA/A,
                                  mean_genes$GCT/A,
                                  mean_genes$GCC/A,
                                  mean_genes$GCG/A,
                                  
                                  mean_genes$GGA/G,
                                  mean_genes$GGT/G,
                                  mean_genes$GGC/G,
                                  mean_genes$GGG/G,
                                  parent_contig = mean_genes$parent_contig)

colnames(rel_props_mean_gene)[1:64] = construct
rel_props_mean_gene[is.nan(rel_props_mean_gene)] <- 0

rel_props_mean_gene <- data.frame(rel_props_mean_gene[match(rel_props$parent_contig, rel_props_mean_gene$parent_contig), 1:64])

distance <- sqrt(rowSums((as.matrix(rel_props[,1:64], ncol = 64)-as.matrix(rel_props_mean_gene, ncol = 64))^2))

if(!dir.exists("MetaPop")){
  dir.create("MetaPop")
}
if(!dir.exists("MetaPop/08.Codon_Bias")){
  dir.create("MetaPop/08.Codon_Bias")
}

fwrite(rel_props, "MetaPop/08.Codon_Bias/codon_usage_proportions.tsv", sep = "\t")

rm(mean_genes, rel_props, rel_props_mean_gene)

colnames(genes) = c("gene", "parent_contig")
genes$euc_dist <- distance

setkey(genes, "parent_contig")
genes_iqr <- genes[, list((quantile(euc_dist, .75)-quantile(euc_dist, .25)), mean(euc_dist)), by = key(genes)]
colnames(genes_iqr)[2:3] = c("iqr","mu")

genes_iqr[,outlier_threshold_distance := mu+1.5*iqr]

genes$outlier_status <- ifelse(genes$euc_dist>genes_iqr$outlier_threshold_distance[match(genes$parent_contig, genes_iqr$parent_contig)], "outlier", "not outlier")

fwrite(genes, "MetaPop/08.Codon_Bias/gene_euclidean_distances.tsv", sep = "\t")
fwrite(genes_iqr, "MetaPop/08.Codon_Bias/gene_IQR_and_mean.tsv", sep = "\t")
